// Begin of spicy_hooks_PostgreSQL (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_postgresql_hlto_scope;

namespace __hlt_postgresql::PostgreSQL {
    struct AuthenticationRequest;
    struct AuthenticationResponse;
    struct BackendKeyData;
    struct Context;
    struct DataRow;
    struct ErrorIdentifiedField;
    struct ErrorResponse;
    struct FrontendMessages;
    struct MaybeBackendSSL;
    struct NotImplemented;
    struct NoticeIdentifiedField;
    struct NoticeResponse;
    struct ParameterStatus;
    struct ProtocolVersion;
    struct ReadyForQuery;
    struct SimpleQuery;
    struct StartupParameter;
    struct StartupMessage;
    struct Terminate;
    HILTI_RT_ENUM_WITH_DEFAULT(SSLBackendState, Undef, S = 0, N = 1, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(SSLFrontendState, Undef, Requested = 0, NotRequested = 1, Undef = -1);;
    struct AuthenticationRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<AuthenticationRequest> {
        auto __self() { return ::hilti::rt::ValueReference<AuthenticationRequest>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> identifier{};
        void __on_identifier(const ::hilti::rt::integer::safe<uint32_t>& __dd);
        std::optional<::hilti::rt::Bytes> data{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__AuthenticationRequest_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint32_t> __p_length{};
        AuthenticationRequest();
        AuthenticationRequest(const AuthenticationRequest&) = default;
        AuthenticationRequest(AuthenticationRequest&&) = default;
        AuthenticationRequest& operator=(const AuthenticationRequest&) = default;
        AuthenticationRequest& operator=(AuthenticationRequest&&) = default;
        AuthenticationRequest(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> identifier, std::optional<std::optional<::hilti::rt::Bytes>> data);
        AuthenticationRequest(const ::hilti::rt::integer::safe<uint32_t>& __p_length);
        template<typename F> void __visit(F _) const { _("identifier", identifier); _("data", data); }
    };

    struct AuthenticationResponse : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<AuthenticationResponse> {
        auto __self() { return ::hilti::rt::ValueReference<AuthenticationResponse>::self(this); }
        std::optional<::hilti::rt::Bytes> data{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__AuthenticationResponse_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        AuthenticationResponse();
        AuthenticationResponse(const AuthenticationResponse&) = default;
        AuthenticationResponse(AuthenticationResponse&&) = default;
        AuthenticationResponse& operator=(const AuthenticationResponse&) = default;
        AuthenticationResponse& operator=(AuthenticationResponse&&) = default;
        AuthenticationResponse(std::optional<std::optional<::hilti::rt::Bytes>> data);
        template<typename F> void __visit(F _) const { _("data", data); }
    };

    struct BackendKeyData : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<BackendKeyData> {
        auto __self() { return ::hilti::rt::ValueReference<BackendKeyData>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> process_id{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> secret_key{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__BackendKeyData_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        BackendKeyData();
        BackendKeyData(const BackendKeyData&) = default;
        BackendKeyData(BackendKeyData&&) = default;
        BackendKeyData& operator=(const BackendKeyData&) = default;
        BackendKeyData& operator=(BackendKeyData&&) = default;
        BackendKeyData(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> process_id, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> secret_key);
        template<typename F> void __visit(F _) const { _("process_id", process_id); _("secret_key", secret_key); }
    };

    struct Context : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Context> {
        auto __self() { return ::hilti::rt::ValueReference<Context>::self(this); }
        PostgreSQL::SSLFrontendState ssl_frontend_state{};
        PostgreSQL::SSLBackendState ssl_backend_state{};
        ::hilti::rt::StrongReference<::spicy::rt::Sink> ssl_sink{};
        ::hilti::rt::Bool ssl_sink_connected{};
        Context();
        Context(const Context&) = default;
        Context(Context&&) = default;
        Context& operator=(const Context&) = default;
        Context& operator=(Context&&) = default;
        Context(std::optional<PostgreSQL::SSLFrontendState> ssl_frontend_state, std::optional<PostgreSQL::SSLBackendState> ssl_backend_state, std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> ssl_sink, std::optional<::hilti::rt::Bool> ssl_sink_connected);
        template<typename F> void __visit(F _) const { _("ssl_frontend_state", ssl_frontend_state); _("ssl_backend_state", ssl_backend_state); _("ssl_sink", ssl_sink); _("ssl_sink_connected", ssl_sink_connected); }
    };

    struct DataRow : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<DataRow> {
        auto __self() { return ::hilti::rt::ValueReference<DataRow>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint16_t>> column_values{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__DataRow_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        DataRow();
        DataRow(const DataRow&) = default;
        DataRow(DataRow&&) = default;
        DataRow& operator=(const DataRow&) = default;
        DataRow& operator=(DataRow&&) = default;
        DataRow(std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> column_values);
        template<typename F> void __visit(F _) const { _("column_values", column_values); }
    };

    struct ErrorIdentifiedField : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ErrorIdentifiedField> {
        auto __self() { return ::hilti::rt::ValueReference<ErrorIdentifiedField>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> code{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ErrorIdentifiedField_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ErrorIdentifiedField();
        ErrorIdentifiedField(const ErrorIdentifiedField&) = default;
        ErrorIdentifiedField(ErrorIdentifiedField&&) = default;
        ErrorIdentifiedField& operator=(const ErrorIdentifiedField&) = default;
        ErrorIdentifiedField& operator=(ErrorIdentifiedField&&) = default;
        ErrorIdentifiedField(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> code, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("code", code); _("value", value); }
    };

    struct ErrorResponse : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ErrorResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ErrorResponse>::self(this); }
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_22_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ErrorIdentifiedField>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ErrorResponse_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ErrorResponse();
        ErrorResponse(const ErrorResponse&) = default;
        ErrorResponse(ErrorResponse&&) = default;
        ErrorResponse& operator=(const ErrorResponse&) = default;
        ErrorResponse& operator=(ErrorResponse&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct FrontendMessages : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<FrontendMessages> {
        auto __self() { return ::hilti::rt::ValueReference<FrontendMessages>::self(this); }
        ::hilti::rt::Vector<::hilti::rt::Bytes> buffered{};
        ::hilti::rt::Bool s1_connected{};
        ::hilti::rt::Bool ssl_requested{};
        ::hilti::rt::StrongReference<::spicy::rt::Sink> s1{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> length{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> version_or_magic{};
        void __on_version_or_magic(const ::hilti::rt::integer::safe<uint32_t>& __dd);
        void __on_ssl_request();
        void __on__anon_5(const ::hilti::rt::Bytes& __dd);
        ::hilti::rt::StrongReference<Context> __context{};
        void __on_0x25_init();
        inline static ::spicy::rt::Parser __parser{};
        ::spicy::rt::sink::detail::State* __sink{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<FrontendMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto context_new() -> ::spicy::rt::UnitContext;
        auto __parse_PostgreSQL__FrontendMessages_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        FrontendMessages();
        FrontendMessages(const FrontendMessages&) = default;
        FrontendMessages(FrontendMessages&&) = default;
        FrontendMessages& operator=(const FrontendMessages&) = default;
        FrontendMessages& operator=(FrontendMessages&&) = default;
        FrontendMessages(std::optional<::hilti::rt::Vector<::hilti::rt::Bytes>> buffered, std::optional<::hilti::rt::Bool> s1_connected, std::optional<::hilti::rt::Bool> ssl_requested, std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> s1, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> length, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> version_or_magic);
        template<typename F> void __visit(F _) const { _("buffered", buffered); _("s1_connected", s1_connected); _("ssl_requested", ssl_requested); _("s1", s1); _("length", length); _("version_or_magic", version_or_magic); }
    };

    struct MaybeBackendSSL : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<MaybeBackendSSL> {
        auto __self() { return ::hilti::rt::ValueReference<MaybeBackendSSL>::self(this); }
        ::hilti::rt::StrongReference<::spicy::rt::Sink> s1{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> ssl_byte{};
        void __on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        ::spicy::rt::sink::detail::State* __sink{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<MaybeBackendSSL>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_PostgreSQL__MaybeBackendSSL_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Context> __p_ctx{};
        MaybeBackendSSL();
        MaybeBackendSSL(const MaybeBackendSSL&) = default;
        MaybeBackendSSL(MaybeBackendSSL&&) = default;
        MaybeBackendSSL& operator=(const MaybeBackendSSL&) = default;
        MaybeBackendSSL& operator=(MaybeBackendSSL&&) = default;
        MaybeBackendSSL(std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> s1, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> ssl_byte);
        MaybeBackendSSL(::hilti::rt::StrongReference<Context> __p_ctx);
        template<typename F> void __visit(F _) const { _("s1", s1); _("ssl_byte", ssl_byte); }
    };

    struct NotImplemented : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<NotImplemented> {
        auto __self() { return ::hilti::rt::ValueReference<NotImplemented>::self(this); }
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__NotImplemented_5_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint8_t> __p_typ{};
        NotImplemented();
        NotImplemented(const NotImplemented&) = default;
        NotImplemented(NotImplemented&&) = default;
        NotImplemented& operator=(const NotImplemented&) = default;
        NotImplemented& operator=(NotImplemented&&) = default;
        NotImplemented(std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        NotImplemented(const ::hilti::rt::integer::safe<uint8_t>& __p_typ);
        template<typename F> void __visit(F _) const { _("chunk", chunk); }
    };

    struct NoticeIdentifiedField : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<NoticeIdentifiedField> {
        auto __self() { return ::hilti::rt::ValueReference<NoticeIdentifiedField>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> code{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__NoticeIdentifiedField_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        NoticeIdentifiedField();
        NoticeIdentifiedField(const NoticeIdentifiedField&) = default;
        NoticeIdentifiedField(NoticeIdentifiedField&&) = default;
        NoticeIdentifiedField& operator=(const NoticeIdentifiedField&) = default;
        NoticeIdentifiedField& operator=(NoticeIdentifiedField&&) = default;
        NoticeIdentifiedField(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> code, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("code", code); _("value", value); }
    };

    struct NoticeResponse : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<NoticeResponse> {
        auto __self() { return ::hilti::rt::ValueReference<NoticeResponse>::self(this); }
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_18_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<NoticeIdentifiedField>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__NoticeResponse_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        NoticeResponse();
        NoticeResponse(const NoticeResponse&) = default;
        NoticeResponse(NoticeResponse&&) = default;
        NoticeResponse& operator=(const NoticeResponse&) = default;
        NoticeResponse& operator=(NoticeResponse&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct ParameterStatus : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ParameterStatus> {
        auto __self() { return ::hilti::rt::ValueReference<ParameterStatus>::self(this); }
        std::optional<::hilti::rt::Bytes> name{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ParameterStatus_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ParameterStatus();
        ParameterStatus(const ParameterStatus&) = default;
        ParameterStatus(ParameterStatus&&) = default;
        ParameterStatus& operator=(const ParameterStatus&) = default;
        ParameterStatus& operator=(ParameterStatus&&) = default;
        ParameterStatus(std::optional<std::optional<::hilti::rt::Bytes>> name, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("name", name); _("value", value); }
    };

    struct ProtocolVersion : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ProtocolVersion> {
        auto __self() { return ::hilti::rt::ValueReference<ProtocolVersion>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint16_t>> major{};
        std::optional<::hilti::rt::integer::safe<uint16_t>> minor{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ProtocolVersion_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ProtocolVersion();
        ProtocolVersion(const ProtocolVersion&) = default;
        ProtocolVersion(ProtocolVersion&&) = default;
        ProtocolVersion& operator=(const ProtocolVersion&) = default;
        ProtocolVersion& operator=(ProtocolVersion&&) = default;
        ProtocolVersion(std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> major, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> minor);
        template<typename F> void __visit(F _) const { _("major", major); _("minor", minor); }
    };

    struct ReadyForQuery : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ReadyForQuery> {
        auto __self() { return ::hilti::rt::ValueReference<ReadyForQuery>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> transaction_status{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ReadyForQuery_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ReadyForQuery();
        ReadyForQuery(const ReadyForQuery&) = default;
        ReadyForQuery(ReadyForQuery&&) = default;
        ReadyForQuery& operator=(const ReadyForQuery&) = default;
        ReadyForQuery& operator=(ReadyForQuery&&) = default;
        ReadyForQuery(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> transaction_status);
        template<typename F> void __visit(F _) const { _("transaction_status", transaction_status); }
    };

    struct SimpleQuery : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SimpleQuery> {
        auto __self() { return ::hilti::rt::ValueReference<SimpleQuery>::self(this); }
        std::optional<::hilti::rt::Bytes> query{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__SimpleQuery_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SimpleQuery();
        SimpleQuery(const SimpleQuery&) = default;
        SimpleQuery(SimpleQuery&&) = default;
        SimpleQuery& operator=(const SimpleQuery&) = default;
        SimpleQuery& operator=(SimpleQuery&&) = default;
        SimpleQuery(std::optional<std::optional<::hilti::rt::Bytes>> query);
        template<typename F> void __visit(F _) const { _("query", query); }
    };

    struct StartupParameter : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<StartupParameter> {
        auto __self() { return ::hilti::rt::ValueReference<StartupParameter>::self(this); }
        std::optional<::hilti::rt::Bytes> name{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__StartupParameter_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        StartupParameter();
        StartupParameter(const StartupParameter&) = default;
        StartupParameter(StartupParameter&&) = default;
        StartupParameter& operator=(const StartupParameter&) = default;
        StartupParameter& operator=(StartupParameter&&) = default;
        StartupParameter(std::optional<std::optional<::hilti::rt::Bytes>> name, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("name", name); _("value", value); }
    };

    struct StartupMessage : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<StartupMessage> {
        auto __self() { return ::hilti::rt::ValueReference<StartupMessage>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> length{};
        std::optional<::hilti::rt::ValueReference<ProtocolVersion>> version{};
        std::optional<::hilti::rt::Vector<StartupParameter>> parameters{};
        void __on_0x25_done();
        void __on_0x25_error(const std::string& __except);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_parameters_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<StartupParameter>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__StartupMessage_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        StartupMessage();
        StartupMessage(const StartupMessage&) = default;
        StartupMessage(StartupMessage&&) = default;
        StartupMessage& operator=(const StartupMessage&) = default;
        StartupMessage& operator=(StartupMessage&&) = default;
        StartupMessage(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> length, std::optional<std::optional<::hilti::rt::ValueReference<ProtocolVersion>>> version, std::optional<std::optional<::hilti::rt::Vector<StartupParameter>>> parameters);
        template<typename F> void __visit(F _) const { _("length", length); _("version", version); _("parameters", parameters); }
    };

    struct Terminate : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Terminate> {
        auto __self() { return ::hilti::rt::ValueReference<Terminate>::self(this); }
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__Terminate_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Terminate();
        Terminate(const Terminate&) = default;
        Terminate(Terminate&&) = default;
        Terminate& operator=(const Terminate&) = default;
        Terminate& operator=(Terminate&&) = default;
        template<typename F> void __visit(F _) const { }
    };

}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_authentication_ok_9c765c58d19923da = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_authentication_response_5bff8e4758ab9d94 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_data_row_3852a5e34150c6b4 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_error_response_1fee3541a6e1eb8a = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_ssl_request_11c518082580dd0c = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_ssl_reply_5b84aa50f8c07ae8 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_notice_response_1edf807677b227c2 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_ready_for_query_af6189d83e09926 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_simple_query_ee50fd7a03c2f826 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_PostgreSQL_terminate_c223029261f544a8 = {};
}

namespace __hlt_postgresql::PostgreSQL {
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::AuthenticationRequest& x) -> std::ostream&;
    extern void __hook_AuthenticationRequest___on_identifier(const ::hilti::rt::integer::safe<uint32_t>& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::AuthenticationRequest>& __self);
    extern void __hook_AuthenticationRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::AuthenticationRequest>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::AuthenticationResponse& x) -> std::ostream&;
    extern void __hook_AuthenticationResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::AuthenticationResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::BackendKeyData& x) -> std::ostream&;
    extern void __hook_BackendKeyData___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::BackendKeyData>& __self);
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_postgresql::PostgreSQL::SSLBackendState x, adl::tag) -> std::string;
}

namespace __hlt_postgresql::PostgreSQL {
    inline auto operator<<(std::ostream& o, SSLBackendState x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_postgresql::PostgreSQL::SSLFrontendState x, adl::tag) -> std::string;
}

namespace __hlt_postgresql::PostgreSQL {
    inline auto operator<<(std::ostream& o, SSLFrontendState x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::Context& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::DataRow& x) -> std::ostream&;
    extern void __hook_DataRow___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::DataRow>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ErrorIdentifiedField& x) -> std::ostream&;
    extern void __hook_ErrorIdentifiedField___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ErrorIdentifiedField>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ErrorResponse& x) -> std::ostream&;
    extern void __hook_ErrorResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ErrorResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::FrontendMessages& x) -> std::ostream&;
    extern void __hook_FrontendMessages___on_version_or_magic(const ::hilti::rt::integer::safe<uint32_t>& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::FrontendMessages>& __self);
    extern void __hook_FrontendMessages___on_ssl_request(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::FrontendMessages>& __self);
    extern void __hook_FrontendMessages___on__anon_5(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::FrontendMessages>& __self);
    extern void __hook_FrontendMessages___on_0x25_init(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::FrontendMessages>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::MaybeBackendSSL& x) -> std::ostream&;
    extern void __hook_MaybeBackendSSL___on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::MaybeBackendSSL>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::NotImplemented& x) -> std::ostream&;
    extern void __hook_NotImplemented___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::NotImplemented>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::NoticeIdentifiedField& x) -> std::ostream&;
    extern void __hook_NoticeIdentifiedField___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::NoticeIdentifiedField>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::NoticeResponse& x) -> std::ostream&;
    extern void __hook_NoticeResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::NoticeResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ParameterStatus& x) -> std::ostream&;
    extern void __hook_ParameterStatus___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ParameterStatus>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ProtocolVersion& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ReadyForQuery& x) -> std::ostream&;
    extern void __hook_ReadyForQuery___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ReadyForQuery>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::SimpleQuery& x) -> std::ostream&;
    extern void __hook_SimpleQuery___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::SimpleQuery>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::StartupParameter& x) -> std::ostream&;
    extern void __hook_StartupParameter___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::StartupParameter>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::StartupMessage& x) -> std::ostream&;
    extern void __hook_StartupMessage___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::StartupMessage>& __self);
    extern void __hook_StartupMessage___on_0x25_error(const std::string& __except, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::StartupMessage>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::Terminate& x) -> std::ostream&;
    extern void __hook_Terminate___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::Terminate>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_AuthenticationRequest___on_0x25_done_6e3d(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_AuthenticationRequest___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_AuthenticationRequest___on_0x25_done_6e3d(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self);
    extern void __hook_AuthenticationRequest___on_0x25_done_792b(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self);
    extern void __hook_AuthenticationRequest___on_0x25_done_792b(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self);
    extern void __hook_AuthenticationResponse___on_0x25_done_9c50(::hilti::rt::ValueReference<PostgreSQL::AuthenticationResponse>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_AuthenticationResponse___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::AuthenticationResponse>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_AuthenticationResponse___on_0x25_done_9c50(::hilti::rt::ValueReference<PostgreSQL::AuthenticationResponse>& __self);
    extern void __hook_BackendKeyData___on_0x25_done_3287(::hilti::rt::ValueReference<PostgreSQL::BackendKeyData>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_BackendKeyData___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::BackendKeyData>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_BackendKeyData___on_0x25_done_3287(::hilti::rt::ValueReference<PostgreSQL::BackendKeyData>& __self);
    extern void __hook_DataRow___on_0x25_done_986e(::hilti::rt::ValueReference<PostgreSQL::DataRow>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_DataRow___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::DataRow>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_DataRow___on_0x25_done_986e(::hilti::rt::ValueReference<PostgreSQL::DataRow>& __self);
    extern void __hook_ErrorIdentifiedField___on_0x25_done_c540(::hilti::rt::ValueReference<PostgreSQL::ErrorIdentifiedField>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_ErrorIdentifiedField___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::ErrorIdentifiedField>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_ErrorIdentifiedField___on_0x25_done_c540(::hilti::rt::ValueReference<PostgreSQL::ErrorIdentifiedField>& __self);
    extern void __hook_ErrorResponse___on_0x25_done_c8b4(::hilti::rt::ValueReference<PostgreSQL::ErrorResponse>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_ErrorResponse___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::ErrorResponse>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_ErrorResponse___on_0x25_done_c8b4(::hilti::rt::ValueReference<PostgreSQL::ErrorResponse>& __self);
    extern void __hook_FrontendMessages___on_ssl_request_6311(::hilti::rt::ValueReference<PostgreSQL::FrontendMessages>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_FrontendMessages___on_ssl_request(::hilti::rt::ValueReference<PostgreSQL::FrontendMessages>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_FrontendMessages___on_ssl_request_6311(::hilti::rt::ValueReference<PostgreSQL::FrontendMessages>& __self);
    extern void __hook_MaybeBackendSSL___on_ssl_byte_bb76(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_MaybeBackendSSL___on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_MaybeBackendSSL___on_ssl_byte_bb76(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self);
    extern void __hook_NotImplemented___on_0x25_done_35d4(::hilti::rt::ValueReference<PostgreSQL::NotImplemented>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_NotImplemented___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::NotImplemented>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_NotImplemented___on_0x25_done_35d4(::hilti::rt::ValueReference<PostgreSQL::NotImplemented>& __self);
    extern void __hook_NoticeIdentifiedField___on_0x25_done_9cf3(::hilti::rt::ValueReference<PostgreSQL::NoticeIdentifiedField>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_NoticeIdentifiedField___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::NoticeIdentifiedField>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_NoticeIdentifiedField___on_0x25_done_9cf3(::hilti::rt::ValueReference<PostgreSQL::NoticeIdentifiedField>& __self);
    extern void __hook_NoticeResponse___on_0x25_done_4be2(::hilti::rt::ValueReference<PostgreSQL::NoticeResponse>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_NoticeResponse___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::NoticeResponse>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_NoticeResponse___on_0x25_done_4be2(::hilti::rt::ValueReference<PostgreSQL::NoticeResponse>& __self);
    extern void __hook_ParameterStatus___on_0x25_done_297(::hilti::rt::ValueReference<PostgreSQL::ParameterStatus>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_ParameterStatus___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::ParameterStatus>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_ParameterStatus___on_0x25_done_297(::hilti::rt::ValueReference<PostgreSQL::ParameterStatus>& __self);
    extern void __hook_ReadyForQuery___on_0x25_done_6c9b(::hilti::rt::ValueReference<PostgreSQL::ReadyForQuery>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_ReadyForQuery___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::ReadyForQuery>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_ReadyForQuery___on_0x25_done_6c9b(::hilti::rt::ValueReference<PostgreSQL::ReadyForQuery>& __self);
    extern void __hook_SimpleQuery___on_0x25_done_b4c2(::hilti::rt::ValueReference<PostgreSQL::SimpleQuery>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_SimpleQuery___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::SimpleQuery>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_SimpleQuery___on_0x25_done_b4c2(::hilti::rt::ValueReference<PostgreSQL::SimpleQuery>& __self);
    extern void __hook_StartupMessage___on_0x25_done_8610(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_StartupMessage___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_StartupMessage___on_0x25_done_8610(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
    extern void __hook_StartupParameter___on_0x25_done_70e9(::hilti::rt::ValueReference<PostgreSQL::StartupParameter>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_StartupParameter___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::StartupParameter>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_StartupParameter___on_0x25_done_70e9(::hilti::rt::ValueReference<PostgreSQL::StartupParameter>& __self);
    extern void __hook_Terminate___on_0x25_done_6237(::hilti::rt::ValueReference<PostgreSQL::Terminate>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_Terminate___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::Terminate>& __self);
}

namespace __hlt_postgresql::spicy_hooks_PostgreSQL {
    extern void __hook_Terminate___on_0x25_done_6237(::hilti::rt::ValueReference<PostgreSQL::Terminate>& __self);
    extern void __init_globals(::hilti::rt::Context* ctx);
    extern void __destroy_globals(::hilti::rt::Context* ctx);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_postgresql::spicy_hooks_PostgreSQL::__register_module)

inline void __hlt_postgresql::PostgreSQL::AuthenticationRequest::__on_0x25_done() {
    auto __self = PostgreSQL::AuthenticationRequest::__self();
    return __hlt_postgresql::PostgreSQL::__hook_AuthenticationRequest___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::AuthenticationRequest::__on_identifier(const ::hilti::rt::integer::safe<uint32_t>& __dd) {
    auto __self = PostgreSQL::AuthenticationRequest::__self();
    return __hlt_postgresql::PostgreSQL::__hook_AuthenticationRequest___on_identifier(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::AuthenticationResponse::__on_0x25_done() {
    auto __self = PostgreSQL::AuthenticationResponse::__self();
    return __hlt_postgresql::PostgreSQL::__hook_AuthenticationResponse___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::BackendKeyData::__on_0x25_done() {
    auto __self = PostgreSQL::BackendKeyData::__self();
    return __hlt_postgresql::PostgreSQL::__hook_BackendKeyData___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::DataRow::__on_0x25_done() {
    auto __self = PostgreSQL::DataRow::__self();
    return __hlt_postgresql::PostgreSQL::__hook_DataRow___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ErrorIdentifiedField::__on_0x25_done() {
    auto __self = PostgreSQL::ErrorIdentifiedField::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ErrorIdentifiedField___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ErrorResponse::__on_0x25_done() {
    auto __self = PostgreSQL::ErrorResponse::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ErrorResponse___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::FrontendMessages::__on_0x25_init() {
    auto __self = PostgreSQL::FrontendMessages::__self();
    return __hlt_postgresql::PostgreSQL::__hook_FrontendMessages___on_0x25_init(__self);
}

inline void __hlt_postgresql::PostgreSQL::FrontendMessages::__on__anon_5(const ::hilti::rt::Bytes& __dd) {
    auto __self = PostgreSQL::FrontendMessages::__self();
    return __hlt_postgresql::PostgreSQL::__hook_FrontendMessages___on__anon_5(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::FrontendMessages::__on_ssl_request() {
    auto __self = PostgreSQL::FrontendMessages::__self();
    return __hlt_postgresql::PostgreSQL::__hook_FrontendMessages___on_ssl_request(__self);
}

inline void __hlt_postgresql::PostgreSQL::FrontendMessages::__on_version_or_magic(const ::hilti::rt::integer::safe<uint32_t>& __dd) {
    auto __self = PostgreSQL::FrontendMessages::__self();
    return __hlt_postgresql::PostgreSQL::__hook_FrontendMessages___on_version_or_magic(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::MaybeBackendSSL::__on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = PostgreSQL::MaybeBackendSSL::__self();
    return __hlt_postgresql::PostgreSQL::__hook_MaybeBackendSSL___on_ssl_byte(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::NotImplemented::__on_0x25_done() {
    auto __self = PostgreSQL::NotImplemented::__self();
    return __hlt_postgresql::PostgreSQL::__hook_NotImplemented___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::NoticeIdentifiedField::__on_0x25_done() {
    auto __self = PostgreSQL::NoticeIdentifiedField::__self();
    return __hlt_postgresql::PostgreSQL::__hook_NoticeIdentifiedField___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::NoticeResponse::__on_0x25_done() {
    auto __self = PostgreSQL::NoticeResponse::__self();
    return __hlt_postgresql::PostgreSQL::__hook_NoticeResponse___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ParameterStatus::__on_0x25_done() {
    auto __self = PostgreSQL::ParameterStatus::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ParameterStatus___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ReadyForQuery::__on_0x25_done() {
    auto __self = PostgreSQL::ReadyForQuery::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ReadyForQuery___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::SimpleQuery::__on_0x25_done() {
    auto __self = PostgreSQL::SimpleQuery::__self();
    return __hlt_postgresql::PostgreSQL::__hook_SimpleQuery___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::StartupMessage::__on_0x25_done() {
    auto __self = PostgreSQL::StartupMessage::__self();
    return __hlt_postgresql::PostgreSQL::__hook_StartupMessage___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::StartupMessage::__on_0x25_error(const std::string& __except) {
    auto __self = PostgreSQL::StartupMessage::__self();
    return __hlt_postgresql::PostgreSQL::__hook_StartupMessage___on_0x25_error(__except, __self);
}

inline void __hlt_postgresql::PostgreSQL::StartupParameter::__on_0x25_done() {
    auto __self = PostgreSQL::StartupParameter::__self();
    return __hlt_postgresql::PostgreSQL::__hook_StartupParameter___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::Terminate::__on_0x25_done() {
    auto __self = PostgreSQL::Terminate::__self();
    return __hlt_postgresql::PostgreSQL::__hook_Terminate___on_0x25_done(__self);
}

inline auto __hlt_postgresql::PostgreSQL::operator<<(std::ostream& o, SSLBackendState x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_postgresql::PostgreSQL::operator<<(std::ostream& o, SSLFrontendState x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__destroy_globals(::hilti::rt::Context* ctx) {
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_ok_9c765c58d19923da.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_response_5bff8e4758ab9d94.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_data_row_3852a5e34150c6b4.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_1fee3541a6e1eb8a.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_request_11c518082580dd0c.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_reply_5b84aa50f8c07ae8.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_1edf807677b227c2.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ready_for_query_af6189d83e09926.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_simple_query_ee50fd7a03c2f826.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30.reset();;
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_terminate_c223029261f544a8.reset();;
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_AuthenticationRequest___on_0x25_done_6e3d(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:10");
    if ( ! (::hilti::rt::optional::value((*__self).identifier) != ::hilti::rt::integer::safe<std::uint32_t>{0U}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:10");
        return;
    }

    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:10");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:10");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).identifier), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).data), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_AuthenticationRequest___on_0x25_done_792b(::hilti::rt::ValueReference<PostgreSQL::AuthenticationRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:12");
    if ( ! (::hilti::rt::optional::value((*__self).identifier) == ::hilti::rt::integer::safe<std::uint32_t>{0U}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:12");
        return;
    }

    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_ok_9c765c58d19923da))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:12");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:12");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{1U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_ok_9c765c58d19923da), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_AuthenticationResponse___on_0x25_done_9c50(::hilti::rt::ValueReference<PostgreSQL::AuthenticationResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:14");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_response_5bff8e4758ab9d94))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:14");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:14");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{2U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).data), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_response_5bff8e4758ab9d94), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_response_5bff8e4758ab9d94), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_BackendKeyData___on_0x25_done_3287(::hilti::rt::ValueReference<PostgreSQL::BackendKeyData>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:42");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:42");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:42");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).process_id), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).secret_key), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_DataRow___on_0x25_done_986e(::hilti::rt::ValueReference<PostgreSQL::DataRow>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:38");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_data_row_3852a5e34150c6b4))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:38");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:38");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{2U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).column_values), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_data_row_3852a5e34150c6b4), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_data_row_3852a5e34150c6b4), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_ErrorIdentifiedField___on_0x25_done_c540(::hilti::rt::ValueReference<PostgreSQL::ErrorIdentifiedField>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:24");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:24");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:24");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::fmt("%c"s, ::hilti::rt::optional::value((*__self).code))), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).value), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_ErrorResponse___on_0x25_done_c8b4(::hilti::rt::ValueReference<PostgreSQL::ErrorResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:26");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_1fee3541a6e1eb8a))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:26");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:26");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{1U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_1fee3541a6e1eb8a), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_FrontendMessages___on_ssl_request_6311(::hilti::rt::ValueReference<PostgreSQL::FrontendMessages>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:16");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_request_11c518082580dd0c))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:16");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:16");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{1U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_request_11c518082580dd0c), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_MaybeBackendSSL___on_ssl_byte_bb76(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:18");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_reply_5b84aa50f8c07ae8))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:18");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:18");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{2U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::fmt("%c"s, ::hilti::rt::optional::value((*__self).ssl_byte))), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_reply_5b84aa50f8c07ae8), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_reply_5b84aa50f8c07ae8), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_NotImplemented___on_0x25_done_35d4(::hilti::rt::ValueReference<PostgreSQL::NotImplemented>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:8");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:8");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:8");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{4U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::fmt("%c"s, __self->__p_typ)), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).chunk), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_NoticeIdentifiedField___on_0x25_done_9cf3(::hilti::rt::ValueReference<PostgreSQL::NoticeIdentifiedField>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:32");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:32");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:32");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::fmt("%c"s, ::hilti::rt::optional::value((*__self).code))), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).value), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_NoticeResponse___on_0x25_done_4be2(::hilti::rt::ValueReference<PostgreSQL::NoticeResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:34");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_1edf807677b227c2))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:34");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:34");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{1U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_1edf807677b227c2), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_ParameterStatus___on_0x25_done_297(::hilti::rt::ValueReference<PostgreSQL::ParameterStatus>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:40");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:40");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:40");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).name), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).value), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_ReadyForQuery___on_0x25_done_6c9b(::hilti::rt::ValueReference<PostgreSQL::ReadyForQuery>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:30");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ready_for_query_af6189d83e09926))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:30");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:30");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{2U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::fmt("%c"s, ::hilti::rt::optional::value((*__self).transaction_status)), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ready_for_query_af6189d83e09926), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ready_for_query_af6189d83e09926), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_SimpleQuery___on_0x25_done_b4c2(::hilti::rt::ValueReference<PostgreSQL::SimpleQuery>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:28");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_simple_query_ee50fd7a03c2f826))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:28");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:28");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{2U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).query), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_simple_query_ee50fd7a03c2f826), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_simple_query_ee50fd7a03c2f826), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_StartupMessage___on_0x25_done_8610(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:22");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:22");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:22");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).version)).major), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).version)).minor), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_StartupParameter___on_0x25_done_70e9(::hilti::rt::ValueReference<PostgreSQL::StartupParameter>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:20");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:20");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:20");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).name), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).value), ::zeek::spicy::rt::event_arg_type((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__hook_Terminate___on_0x25_done_6237(::hilti::rt::ValueReference<PostgreSQL::Terminate>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:36");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_terminate_c223029261f544a8))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:36");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql.evt:36");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{1U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    ::zeek::spicy::rt::raise_event((*__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_terminate_c223029261f544a8), std::move(args));
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__init_globals(::hilti::rt::Context* ctx) {
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_request_1f7d6360a6b1003a = ::zeek::spicy::rt::internal_handler("PostgreSQL::authentication_request"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_ok_9c765c58d19923da = ::zeek::spicy::rt::internal_handler("PostgreSQL::authentication_ok"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_authentication_response_5bff8e4758ab9d94 = ::zeek::spicy::rt::internal_handler("PostgreSQL::authentication_response"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_backend_key_data_4ef6186509c5929c = ::zeek::spicy::rt::internal_handler("PostgreSQL::backend_key_data"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_data_row_3852a5e34150c6b4 = ::zeek::spicy::rt::internal_handler("PostgreSQL::data_row"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_identified_field_5863caff97e017a6 = ::zeek::spicy::rt::internal_handler("PostgreSQL::error_response_identified_field"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_error_response_1fee3541a6e1eb8a = ::zeek::spicy::rt::internal_handler("PostgreSQL::error_response"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_request_11c518082580dd0c = ::zeek::spicy::rt::internal_handler("PostgreSQL::ssl_request"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ssl_reply_5b84aa50f8c07ae8 = ::zeek::spicy::rt::internal_handler("PostgreSQL::ssl_reply"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_not_implemented_886feec5ffd00462 = ::zeek::spicy::rt::internal_handler("PostgreSQL::not_implemented"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_identified_field_5a7a511aeb5cdf6c = ::zeek::spicy::rt::internal_handler("PostgreSQL::notice_response_identified_field"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_notice_response_1edf807677b227c2 = ::zeek::spicy::rt::internal_handler("PostgreSQL::notice_response"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_parameter_status_6eb99e0832c363d8 = ::zeek::spicy::rt::internal_handler("PostgreSQL::parameter_status"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_ready_for_query_af6189d83e09926 = ::zeek::spicy::rt::internal_handler("PostgreSQL::ready_for_query"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_simple_query_ee50fd7a03c2f826 = ::zeek::spicy::rt::internal_handler("PostgreSQL::simple_query"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_message_3e5fc2000a80a700 = ::zeek::spicy::rt::internal_handler("PostgreSQL::startup_message"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_startup_parameter_69dc78547dc02a30 = ::zeek::spicy::rt::internal_handler("PostgreSQL::startup_parameter"s);
    ::__hlt_postgresql::spicy_hooks_PostgreSQL::__zeek_handler_PostgreSQL_terminate_c223029261f544a8 = ::zeek::spicy::rt::internal_handler("PostgreSQL::terminate"s);
}

extern void __hlt_postgresql::spicy_hooks_PostgreSQL::__register_module() { ::hilti::rt::detail::registerModule({ "spicy_hooks_PostgreSQL", __hlt_postgresql_hlto_scope, nullptr, &__init_globals, &__destroy_globals, nullptr}); }

inline auto hilti::rt::detail::adl::to_string(__hlt_postgresql::PostgreSQL::SSLBackendState x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_postgresql::PostgreSQL::SSLBackendState::N: return "SSLBackendState::N";
        case __hlt_postgresql::PostgreSQL::SSLBackendState::S: return "SSLBackendState::S";
        case __hlt_postgresql::PostgreSQL::SSLBackendState::Undef: return "SSLBackendState::Undef";
        default: return ::hilti::rt::fmt("SSLBackendState::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_postgresql::PostgreSQL::SSLFrontendState x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_postgresql::PostgreSQL::SSLFrontendState::NotRequested: return "SSLFrontendState::NotRequested";
        case __hlt_postgresql::PostgreSQL::SSLFrontendState::Requested: return "SSLFrontendState::Requested";
        case __hlt_postgresql::PostgreSQL::SSLFrontendState::Undef: return "SSLFrontendState::Undef";
        default: return ::hilti::rt::fmt("SSLFrontendState::<unknown-%" PRIu64 ">", x.value());
    }
}

