// Begin of spicy_hooks_Syslog (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_syslog_hlto_scope;

namespace __hlt_syslog::Syslog {
    struct Priority;
    struct Message;
    struct Priority : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Priority> {
        auto __self() { return ::hilti::rt::ValueReference<Priority>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint64_t>> value{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Syslog__Priority_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Priority();
        Priority(const Priority&) = default;
        Priority(Priority&&) = default;
        Priority& operator=(const Priority&) = default;
        Priority& operator=(Priority&&) = default;
        Priority(std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> value);
        template<typename F> void __visit(F _) const { _("value", value); }
    };

    struct Message : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Message> {
        auto __self() { return ::hilti::rt::ValueReference<Message>::self(this); }
        std::optional<::hilti::rt::ValueReference<Priority>> prio{};
        std::optional<::hilti::rt::Bytes> msg{};
        ::hilti::rt::integer::safe<uint64_t> severity{};
        ::hilti::rt::integer::safe<uint64_t> facility{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Syslog__Message_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Message();
        Message(const Message&) = default;
        Message(Message&&) = default;
        Message& operator=(const Message&) = default;
        Message& operator=(Message&&) = default;
        Message(std::optional<std::optional<::hilti::rt::ValueReference<Priority>>> prio, std::optional<std::optional<::hilti::rt::Bytes>> msg, std::optional<::hilti::rt::integer::safe<uint64_t>> severity, std::optional<::hilti::rt::integer::safe<uint64_t>> facility);
        template<typename F> void __visit(F _) const { _("prio", prio); _("msg", msg); _("severity", severity); _("facility", facility); }
    };

}

namespace __hlt_syslog::spicy_hooks_Syslog {
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_syslog_message_55b2a4c954e38b0f = {};
}

namespace __hlt_syslog::Syslog {
    extern auto operator<<(std::ostream& o, const __hlt_syslog::Syslog::Priority& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_syslog::Syslog::Message& x) -> std::ostream&;
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message>& __self);
}

namespace __hlt_syslog::spicy_hooks_Syslog {
    extern void __hook_Message___on_0x25_done_f661(::hilti::rt::ValueReference<Syslog::Message>& __self);
}

namespace __hlt_syslog::Syslog {
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<Syslog::Message>& __self);
}

namespace __hlt_syslog::spicy_hooks_Syslog {
    extern void __hook_Message___on_0x25_done_f661(::hilti::rt::ValueReference<Syslog::Message>& __self);
    extern void __init_globals(::hilti::rt::Context* ctx);
    extern void __destroy_globals(::hilti::rt::Context* ctx);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_syslog::spicy_hooks_Syslog::__register_module)

inline void __hlt_syslog::Syslog::Message::__on_0x25_done() {
    auto __self = Syslog::Message::__self();
    return __hlt_syslog::Syslog::__hook_Message___on_0x25_done(__self);
}

extern void __hlt_syslog::spicy_hooks_Syslog::__destroy_globals(::hilti::rt::Context* ctx) { ::__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f.reset();; }

extern void __hlt_syslog::spicy_hooks_Syslog::__hook_Message___on_0x25_done_f661(::hilti::rt::ValueReference<Syslog::Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.evt:11");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.evt:11");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.evt:11");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{4U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).facility, ::zeek::spicy::rt::event_arg_type((*__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).severity, ::zeek::spicy::rt::event_arg_type((*__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).msg), ::zeek::spicy::rt::event_arg_type((*__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    ::zeek::spicy::rt::raise_event((*__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f), std::move(args));
}

extern void __hlt_syslog::spicy_hooks_Syslog::__init_globals(::hilti::rt::Context* ctx) { ::__hlt_syslog::spicy_hooks_Syslog::__zeek_handler_syslog_message_55b2a4c954e38b0f = ::zeek::spicy::rt::internal_handler("syslog_message"s); }

extern void __hlt_syslog::spicy_hooks_Syslog::__register_module() { ::hilti::rt::detail::registerModule({ "spicy_hooks_Syslog", __hlt_syslog_hlto_scope, nullptr, &__init_globals, &__destroy_globals, nullptr}); }
