// Begin of WebSocket (from "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_websocket_hlto_scope;

namespace __hlt_websocket::WebSocket {
    struct CloseFrame;
    struct Message;
    struct Frame;
    struct Messages;
    struct CloseFrame : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<CloseFrame> {
        auto __self() { return ::hilti::rt::ValueReference<CloseFrame>::self(this); }
        ::hilti::rt::integer::safe<uint16_t> status{};
        ::hilti::rt::Bytes reason{};
        void __on__anon_6(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__CloseFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        CloseFrame();
        CloseFrame(const CloseFrame&) = default;
        CloseFrame(CloseFrame&&) = default;
        CloseFrame& operator=(const CloseFrame&) = default;
        CloseFrame& operator=(CloseFrame&&) = default;
        CloseFrame(std::optional<::hilti::rt::integer::safe<uint16_t>> status, std::optional<::hilti::rt::Bytes> reason);
        template<typename F> void __visit(F _) const { _("status", status); _("reason", reason); }
    };

    struct Message : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Message> {
        auto __self() { return ::hilti::rt::ValueReference<Message>::self(this); }
        ::hilti::rt::Bool done{};
        ::hilti::rt::integer::safe<uint8_t> opcode{};
        std::optional<::hilti::rt::ValueReference<Frame>> first_frame{};
        void __on_first_frame(const ::hilti::rt::ValueReference<Frame>& __dd);
        void __on__anon_8_foreach(const ::hilti::rt::ValueReference<Frame>& __dd, ::hilti::rt::Bool& __stop);
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse__anon_8_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<Frame>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__Message_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Message();
        Message(const Message&) = default;
        Message(Message&&) = default;
        Message& operator=(const Message&) = default;
        Message& operator=(Message&&) = default;
        Message(std::optional<::hilti::rt::Bool> done, std::optional<::hilti::rt::integer::safe<uint8_t>> opcode, std::optional<std::optional<::hilti::rt::ValueReference<Frame>>> first_frame);
        template<typename F> void __visit(F _) const { _("done", done); _("opcode", opcode); _("first_frame", first_frame); }
    };

    struct Frame : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<Frame> {
        auto __self() { return ::hilti::rt::ValueReference<Frame>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> payload_len{};
        ::hilti::rt::integer::safe<uint64_t> masking_key_idx{};
        ::hilti::rt::Bytes close_data{};
        ::hilti::rt::integer::safe<uint8_t> effective_opcode{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>> _anon{};
        void __on__anon_3();
        std::optional<::hilti::rt::integer::safe<uint16_t>> payload_len2{};
        std::optional<::hilti::rt::integer::safe<uint64_t>> payload_len8{};
        void __on__anon_4();
        std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>> masking_key{};
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_chunk(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_masking_key_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__Frame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_m{};
        Frame();
        Frame(const Frame&) = default;
        Frame(Frame&&) = default;
        Frame& operator=(const Frame&) = default;
        Frame& operator=(Frame&&) = default;
        Frame(std::optional<::hilti::rt::integer::safe<uint64_t>> payload_len, std::optional<::hilti::rt::integer::safe<uint64_t>> masking_key_idx, std::optional<::hilti::rt::Bytes> close_data, std::optional<::hilti::rt::integer::safe<uint8_t>> effective_opcode, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>>> _anon, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> payload_len2, std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> payload_len8, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>> masking_key, std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        Frame(const ::hilti::rt::ValueReference<Message>& __p_m);
        template<typename F> void __visit(F _) const { _("payload_len", payload_len); _("masking_key_idx", masking_key_idx); _("close_data", close_data); _("effective_opcode", effective_opcode); _("<anon>", _anon); _("payload_len2", payload_len2); _("payload_len8", payload_len8); _("masking_key", masking_key); _("chunk", chunk); }
    };

    struct Messages : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Messages> {
        auto __self() { return ::hilti::rt::ValueReference<Messages>::self(this); }
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse__anon_11_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__Messages_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Messages();
        Messages(const Messages&) = default;
        Messages(Messages&&) = default;
        Messages& operator=(const Messages&) = default;
        Messages& operator=(Messages&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    const ::hilti::rt::integer::safe<uint64_t> OPCODE_BINARY = ::hilti::rt::integer::safe<std::uint64_t>{2U};
    const ::hilti::rt::integer::safe<uint64_t> OPCODE_CLOSE = ::hilti::rt::integer::safe<std::uint64_t>{8U};
    const ::hilti::rt::integer::safe<uint64_t> OPCODE_CONTINUATION = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    const ::hilti::rt::integer::safe<uint64_t> OPCODE_PING = ::hilti::rt::integer::safe<std::uint64_t>{9U};
    const ::hilti::rt::integer::safe<uint64_t> OPCODE_PONG = ::hilti::rt::integer::safe<std::uint64_t>{10U};
    const ::hilti::rt::integer::safe<uint64_t> OPCODE_TEXT = ::hilti::rt::integer::safe<std::uint64_t>{1U};
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40CloseFrame0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Frame0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Message0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25WebSocket0x400x40Messages0x25uses_sync_advance = ::hilti::rt::Bool(false);
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::CloseFrame& x) -> std::ostream&;
    extern void __hook_CloseFrame___on__anon_6(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::CloseFrame>& __self);
    extern void __hook_CloseFrame___on_0x25_done(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::CloseFrame>& __self);
    CloseFrame::CloseFrame() {
    }

    CloseFrame::CloseFrame(std::optional<::hilti::rt::integer::safe<uint16_t>> status, std::optional<::hilti::rt::Bytes> reason) : CloseFrame() {
        if ( status ) this->status = std::move(*status);
        if ( reason ) this->reason = std::move(*reason);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Message& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Frame& x) -> std::ostream&;
    extern void __hook_Message___on_first_frame(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __self);
    extern void __hook_Message___on__anon_8_foreach(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __self);
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __self);
    Message::Message() {
        done = ::hilti::rt::Bool(false);
    }

    Message::Message(std::optional<::hilti::rt::Bool> done, std::optional<::hilti::rt::integer::safe<uint8_t>> opcode, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>>> first_frame) : Message() {
        if ( done ) this->done = std::move(*done);
        if ( opcode ) this->opcode = std::move(*opcode);
        if ( first_frame ) this->first_frame = std::move(*first_frame);
    }

    
    extern void __hook_Frame___on__anon_3(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    extern void __hook_Frame___on__anon_4(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    extern void __hook_Frame___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    extern void __hook_Frame___on_0x25_done(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    Frame::Frame() {
    }

    Frame::Frame(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __p_m) : __p_m(std::move(__p_m)) {
    }

    Frame::Frame(std::optional<::hilti::rt::integer::safe<uint64_t>> payload_len, std::optional<::hilti::rt::integer::safe<uint64_t>> masking_key_idx, std::optional<::hilti::rt::Bytes> close_data, std::optional<::hilti::rt::integer::safe<uint8_t>> effective_opcode, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>>> _anon, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> payload_len2, std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> payload_len8, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>> masking_key, std::optional<std::optional<::hilti::rt::Bytes>> chunk) : Frame() {
        if ( payload_len ) this->payload_len = std::move(*payload_len);
        if ( masking_key_idx ) this->masking_key_idx = std::move(*masking_key_idx);
        if ( close_data ) this->close_data = std::move(*close_data);
        if ( effective_opcode ) this->effective_opcode = std::move(*effective_opcode);
        if ( _anon ) this->_anon = std::move(*_anon);
        if ( payload_len2 ) this->payload_len2 = std::move(*payload_len2);
        if ( payload_len8 ) this->payload_len8 = std::move(*payload_len8);
        if ( masking_key ) this->masking_key = std::move(*masking_key);
        if ( chunk ) this->chunk = std::move(*chunk);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Messages& x) -> std::ostream&;
    Messages::Messages() {
    }

    
    extern void __hook_CloseFrame___on__anon_6_8edc(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CloseFrame>& __self);
    extern void __hook_CloseFrame___on__anon_6(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CloseFrame>& __self);
    extern void __hook_CloseFrame___on__anon_6_8edc(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CloseFrame>& __self);
    extern void __hook_Frame___on__anon_3_8934(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_3(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_3_8934(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_4_1eca(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_4(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_4_1eca(::hilti::rt::ValueReference<Frame>& __self);
}

namespace hlt_websocket::WebSocket {
    extern auto fast_unmask(const ::hilti::rt::integer::safe<uint64_t>& masking_key_idx, const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& masking_key, const ::hilti::rt::Bytes& chunk) -> ::hilti::rt::Bytes;
}

namespace zeek::spicy::rt {
    extern auto is_orig() -> ::hilti::rt::Bool;
}

namespace zeek::spicy::rt {
    extern void protocol_data_in(const ::hilti::rt::Bool& is_orig, const ::hilti::rt::Bytes& data, const ::hilti::rt::Protocol& protocol);
}

namespace __hlt_websocket::WebSocket {
    extern void __hook_Frame___on_chunk_1151(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on_chunk_1151(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Frame>& __self);
}

namespace spicy::rt {
    extern void accept_input();
}

namespace __hlt_websocket::WebSocket {
    extern void __hook_Message___on_0x25_done_74cc(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_0x25_done_74cc(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_8_foreach_ca51(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_8_foreach(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_8_foreach_ca51(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_first_frame_c21(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_first_frame(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_first_frame_c21(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::ValueReference<Message>& __self);
}

namespace hlt_websocket::WebSocket::Message {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace hlt_websocket::WebSocket::Messages {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_websocket::WebSocket {
    extern void __register_WebSocket_CloseFrame();
    extern void __register_WebSocket_Frame();
    extern void __register_WebSocket_Message();
    extern void __register_WebSocket_Messages();
    extern void __init_module();
    extern void __register_module();
}

namespace __hlt_websocket::type_info { namespace {
    extern const ::hilti::rt::TypeInfo __ti_WebSocket__CloseFrame_namex2aWebSocket__CloseFramex2b;
    extern const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b;
    const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b = { "hilti::RecoverableFailure", "hilti::RecoverableFailure", new ::hilti::rt::type_info::Exception() };
    const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b = { {}, "optional<spicy::RecoverableFailure>", new ::hilti::rt::type_info::Optional(&type_info::__ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::RecoverableFailure>()) };
    const ::hilti::rt::TypeInfo __ti_WebSocket__CloseFrame_namex2aWebSocket__CloseFramex2b = { "WebSocket::CloseFrame", "WebSocket::CloseFrame", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "status", &::hilti::rt::type_info::uint16, offsetof(WebSocket::CloseFrame, status), false, false }, ::hilti::rt::type_info::struct_::Field{ "reason", &::hilti::rt::type_info::bytes, offsetof(WebSocket::CloseFrame, reason), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(WebSocket::CloseFrame, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_WebSocket__Message_namex2aWebSocket__Messagex2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_Frame__value_refx2anamex2aWebSocket__Framex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_WebSocket__Frame_namex2aWebSocket__Framex2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a16x2b_x73_fin__0_x28convertx31cast_bool_x2a__ddx2bx3e_rsv__1__3x3e_opcode__4__7_x28convertx31cast_uint_8__x2a__ddx2bx3e_mask__8_x28convertx31cast_bool_x2a__ddx2bx3e_payload_len1__9__15x3e_x75_bitfieldx2a16_fin_0_0_rsv_1_3_opcode_4_7_mask_8_8_payload_len1_9_15_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a16x2b_x73_fin__0_x28convertx31cast_bool_x2a__ddx2bx3e_rsv__1__3x3e_opcode__4__7_x28convertx31cast_uint_8__x2a__ddx2bx3e_mask__8_x28convertx31cast_bool_x2a__ddx2bx3e_payload_len1__9__15x3e_x75_bitfieldx2a16_fin_0_0_rsv_1_3_opcode_4_7_mask_8_8_payload_len1_9_15_x2b = { {}, "bitfield(16) { fin: 0 &convert=cast<bool>(__dd); rsv: 1..3; opcode: 4..7 &convert=cast<uint<8>>(__dd); mask: 8 &convert=cast<bool>(__dd); payload_len1: 9..15; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "fin", &::hilti::rt::type_info::bool_, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "rsv", &::hilti::rt::type_info::uint16, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>, 1>() }, ::hilti::rt::type_info::bitfield::Bits{ "opcode", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>, 2>() }, ::hilti::rt::type_info::bitfield::Bits{ "mask", &::hilti::rt::type_info::bool_, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>, 3>() }, ::hilti::rt::type_info::bitfield::Bits{ "payload_len1", &::hilti::rt::type_info::uint16, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>, 4>() }})) };
    extern const ::hilti::rt::TypeInfo __ti_vector_uint_8___vectorx2auint8x2b;
    const ::hilti::rt::TypeInfo __ti_vector_uint_8___vectorx2auint8x2b = { {}, "vector<uint<8>>", new ::hilti::rt::type_info::Vector(&::hilti::rt::type_info::uint8, ::hilti::rt::type_info::Vector::accessor<::hilti::rt::integer::safe<uint8_t>>()) };
    const ::hilti::rt::TypeInfo __ti_WebSocket__Frame_namex2aWebSocket__Framex2b = { "WebSocket::Frame", "WebSocket::Frame", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "payload_len", &::hilti::rt::type_info::uint64, offsetof(WebSocket::Frame, payload_len), false, false }, ::hilti::rt::type_info::struct_::Field{ "masking_key_idx", &::hilti::rt::type_info::uint64, offsetof(WebSocket::Frame, masking_key_idx), false, false }, ::hilti::rt::type_info::struct_::Field{ "close_data", &::hilti::rt::type_info::bytes, offsetof(WebSocket::Frame, close_data), false, false }, ::hilti::rt::type_info::struct_::Field{ "effective_opcode", &::hilti::rt::type_info::uint8, offsetof(WebSocket::Frame, effective_opcode), false, false }, ::hilti::rt::type_info::struct_::Field{ "_anon", &type_info::__ti_bitfieldx2a16x2b_x73_fin__0_x28convertx31cast_bool_x2a__ddx2bx3e_rsv__1__3x3e_opcode__4__7_x28convertx31cast_uint_8__x2a__ddx2bx3e_mask__8_x28convertx31cast_bool_x2a__ddx2bx3e_payload_len1__9__15x3e_x75_bitfieldx2a16_fin_0_0_rsv_1_3_opcode_4_7_mask_8_8_payload_len1_9_15_x2b, offsetof(WebSocket::Frame, _anon), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "payload_len2", &::hilti::rt::type_info::uint16, offsetof(WebSocket::Frame, payload_len2), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint16_t>>() }, ::hilti::rt::type_info::struct_::Field{ "payload_len8", &::hilti::rt::type_info::uint64, offsetof(WebSocket::Frame, payload_len8), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "masking_key", &type_info::__ti_vector_uint_8___vectorx2auint8x2b, offsetof(WebSocket::Frame, masking_key), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "chunk", &::hilti::rt::type_info::bytes, offsetof(WebSocket::Frame, chunk), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(WebSocket::Frame, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_Frame__value_refx2anamex2aWebSocket__Framex2bx2b = { {}, "value_ref<Frame>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_WebSocket__Frame_namex2aWebSocket__Framex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_websocket::WebSocket::Frame>()) };
    const ::hilti::rt::TypeInfo __ti_WebSocket__Message_namex2aWebSocket__Messagex2b = { "WebSocket::Message", "WebSocket::Message", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "done", &::hilti::rt::type_info::bool_, offsetof(WebSocket::Message, done), false, false }, ::hilti::rt::type_info::struct_::Field{ "opcode", &::hilti::rt::type_info::uint8, offsetof(WebSocket::Message, opcode), false, false }, ::hilti::rt::type_info::struct_::Field{ "first_frame", &type_info::__ti_value_ref_Frame__value_refx2anamex2aWebSocket__Framex2bx2b, offsetof(WebSocket::Message, first_frame), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(WebSocket::Message, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_WebSocket__Messages_namex2aWebSocket__Messagesx2b;
    const ::hilti::rt::TypeInfo __ti_WebSocket__Messages_namex2aWebSocket__Messagesx2b = { "WebSocket::Messages", "WebSocket::Messages", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(WebSocket::Messages, __error), true, false }})) };
} }

HILTI_PRE_INIT(__hlt_websocket::WebSocket::__register_module)

inline void __hlt_websocket::WebSocket::CloseFrame::__on_0x25_done() {
    auto __self = WebSocket::CloseFrame::__self();
    return __hlt_websocket::WebSocket::__hook_CloseFrame___on_0x25_done(__self);
}

inline void __hlt_websocket::WebSocket::CloseFrame::__on__anon_6(const ::hilti::rt::Bytes& __dd) {
    auto __self = WebSocket::CloseFrame::__self();
    return __hlt_websocket::WebSocket::__hook_CloseFrame___on__anon_6(__dd, __self);
}

auto __hlt_websocket::WebSocket::CloseFrame::__parse_WebSocket__CloseFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_1;
    auto __self = CloseFrame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:80:19-90:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient__anon_6;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:84:5-84:9");

    // Begin parsing production: Variable: _anon_6 -> bytes;
    ::spicy::rt::detail::waitForEod(__data, __cur, (__lhs_1=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
    __transient__anon_6 = __cur.data();
    __cur = __cur.advance(__cur.size());
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_6 -> bytes;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:84:3-89:3");
    (*__self).__on__anon_6(__transient__anon_6);
    __error = (*__self).__error;
    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:80:19-90:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::CloseFrame::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CloseFrame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:80:19-90:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_WebSocket__CloseFrame_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_websocket::WebSocket::Frame::__on_0x25_done() {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on_0x25_done(__self);
}

inline void __hlt_websocket::WebSocket::Frame::__on__anon_3() {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on__anon_3(__self);
}

inline void __hlt_websocket::WebSocket::Frame::__on__anon_4() {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on__anon_4(__self);
}

inline void __hlt_websocket::WebSocket::Frame::__on_chunk(const ::hilti::rt::Bytes& __dd) {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on_chunk(__dd, __self);
}

auto __hlt_websocket::WebSocket::Frame::__parse_WebSocket__Frame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::stream::View>> __x_1;
    auto __self = Frame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:21:14-78:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:27:5-33:3");

    // Begin parsing production: Variable: _anon -> bitfield(16) { fin: 0 &convert=cast<bool>(__dd); rsv: 1..3; opcode: 4..7 &convert=cast<uint<8>>(__dd); mask: 8 &convert=cast<bool>(__dd); payload_len1: 9..15; };
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{2U}, "expecting 2 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:27:5-33:3"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(::hilti::rt::optional::valueOrInit((*__self)._anon), __cur) = (__x_1 = ::hilti::rt::integer::unpack<uint16_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(::hilti::rt::Bool(static_cast<bool>(::hilti::rt::integer::bits(std::get<0>(*__x_1), 0, 0, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::MSB0}))), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 1, 3, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::MSB0}), static_cast<::hilti::rt::integer::safe<uint8_t>>(::hilti::rt::integer::bits(std::get<0>(*__x_1), 4, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::MSB0})), ::hilti::rt::Bool(static_cast<bool>(::hilti::rt::integer::bits(std::get<0>(*__x_1), 8, 8, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::MSB0}))), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 9, 15, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::MSB0}), ::hilti::rt::integer::noop(std::get<0>(*__x_1))), std::get<1>(*__x_1)))).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon -> bitfield(16) { fin: 0 &convert=cast<bool>(__dd); rsv: 1..3; opcode: 4..7 &convert=cast<uint<8>>(__dd); mask: 8 &convert=cast<bool>(__dd); payload_len1: 9..15; };

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:37:5-37:8");

    // Begin parsing production: Variable: _anon_2 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_2 -> void;

    {
        ::hilti::rt::Result<::hilti::rt::Nothing> __requires = ((((::hilti::rt::integer::safe<uint64_t>((*__self->__p_m.derefAsValue()).opcode) != __hlt_websocket::WebSocket::OPCODE_CONTINUATION) && (::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self)._anon).value)))) == __hlt_websocket::WebSocket::OPCODE_CONTINUATION)) || ((::hilti::rt::integer::safe<uint64_t>((*__self->__p_m.derefAsValue()).opcode) == __hlt_websocket::WebSocket::OPCODE_CONTINUATION) && (::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self)._anon).value)))) != __hlt_websocket::WebSocket::OPCODE_CONTINUATION))) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: (m.opcode != OPCODE_CONTINUATION &* self.opcode == OPCODE_CONTINUATION || m.opcode == OPCODE_CONTINUATION &* self.opcode != OPCODE_CONTINUATION)"));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:37:10-37:163");
            throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:37:10-37:163");
        }
    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:40:5-40:8");

    // Begin parsing production: Variable: _anon_3 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_3 -> void;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:40:3-42:3");
    (*__self).__on__anon_3();
    __error = (*__self).__error;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:44:17-44:22");
        if ( (::hilti::rt::optional::value(std::get<4>(::hilti::rt::optional::value((*__self)._anon).value))) == ::hilti::rt::integer::safe<std::uint16_t>{126U} ) {
            // Begin parsing production: Variable: payload_len2 -> uint<16>;
            ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{2U}, "expecting 2 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:44:17-44:22"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            std::tie(::hilti::rt::optional::valueOrInit((*__self).payload_len2), __cur) = ::hilti::rt::integer::unpack<uint16_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: payload_len2 -> uint<16>;
        }
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:45:17-45:22");
        if ( (::hilti::rt::optional::value(std::get<4>(::hilti::rt::optional::value((*__self)._anon).value))) == ::hilti::rt::integer::safe<std::uint16_t>{127U} ) {
            // Begin parsing production: Variable: payload_len8 -> uint<64>;
            ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{8U}, "expecting 8 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:45:17-45:22"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            std::tie(::hilti::rt::optional::valueOrInit((*__self).payload_len8), __cur) = ::hilti::rt::integer::unpack<uint64_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: payload_len8 -> uint<64>;
        }
    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:47:5-47:8");

    // Begin parsing production: Variable: _anon_4 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_4 -> void;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:47:3-53:3");
    (*__self).__on__anon_4();
    __error = (*__self).__error;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:3-58:46");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};
        if ( (::hilti::rt::optional::value(std::get<3>(::hilti::rt::optional::value((*__self)._anon).value))) ) {
            // Begin parsing production: ForEach: masking_key -> foreach: _anon_5;
            ::hilti::rt::stream::View __limited_ = __cur.limit(::hilti::rt::integer::safe<std::uint64_t>{4U});
            ::hilti::rt::stream::View __ncur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{4U});
            std::tie(__limited_, __lah, __lahe, __error) = (*__self).__parse_masking_key_stage1(__data, __begin, __limited_, __trim, __lah, __lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).masking_key));
            if ( __limited_.offset() < __ncur.offset() ) {
                (*__self).masking_key.reset();
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:24-58:30");
                throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, ::hilti::rt::integer::safe<std::uint64_t>{4U}, __limited_.offset() - (__ncur.offset() - ::hilti::rt::integer::safe<std::uint64_t>{4U})), "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:24-58:30");
            }

            // End parsing production: ForEach: masking_key -> foreach: _anon_5;

            ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
            __cur = __ncur;
        }
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:60:10-60:14");

        // Begin parsing production: Variable: chunk -> bytes;
        ::hilti::rt::stream::View __limited_ = __cur.limit((*__self).payload_len);
        ::hilti::rt::stream::View __ncur = __cur.advance((*__self).payload_len);
        while ( ::hilti::rt::Bool(true) ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_2;
            ::hilti::rt::Bool more_data = ::spicy::rt::detail::waitForInputOrEod(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_2=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            if ( ::hilti::rt::Bool(static_cast<bool>(__limited_.size())) ) {
                ::hilti::rt::optional::valueOrInit((*__self).chunk) = __limited_.data();
                __limited_ = __limited_.advance(__limited_.size());
                if ( __trim ) {
                    (*__data).trim(__limited_.begin());
                }

                (*__self).__error = __error;
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:60:3-77:3");
                (*__self).__on_chunk(::hilti::rt::optional::value((*__self).chunk));
                __error = (*__self).__error;
            }

            if ( ! (more_data) ) {
                break;
            }
        }

        if ( __trim ) {
            (*__data).trim(__limited_.begin());
        }

        if ( __limited_.offset() < __ncur.offset() ) {
            (*__self).chunk.reset();
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:60:16-60:37");
            throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*__self).payload_len, __limited_.offset() - (__ncur.offset() - (*__self).payload_len)), "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:60:16-60:37");
        }

        // End parsing production: Variable: chunk -> bytes;

        __cur = __ncur;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:21:14-78:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::Frame::__parse_masking_key_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_3;
    auto __self = Frame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:3-58:46");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_3=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_4;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::integer::safe<uint8_t> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:16-58:20");

        // Begin parsing production: Variable: _anon_5 -> uint<8> (container 'masking_key');
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:16-58:20"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__elem, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_5 -> uint<8> (container 'masking_key');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
        }

        if ( ! (__stop) ) {
            __dst.emplace_back(__elem);
        }

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_4=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:3-58:46");
            throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:58:3-58:46");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::Frame::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Frame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:21:14-78:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_WebSocket__Frame_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_websocket::WebSocket::Message::__on_0x25_done() {
    auto __self = WebSocket::Message::__self();
    return __hlt_websocket::WebSocket::__hook_Message___on_0x25_done(__self);
}

inline void __hlt_websocket::WebSocket::Message::__on__anon_8_foreach(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = WebSocket::Message::__self();
    return __hlt_websocket::WebSocket::__hook_Message___on__anon_8_foreach(__dd, __stop, __self);
}

inline void __hlt_websocket::WebSocket::Message::__on_first_frame(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd) {
    auto __self = WebSocket::Message::__self();
    return __hlt_websocket::WebSocket::__hook_Message___on_first_frame(__dd, __self);
}

auto __hlt_websocket::WebSocket::Message::__parse_WebSocket__Message_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:21:14-78:1");

        // Begin parsing production: Unit: WebSocket__Frame_2 -> _anon_7 _anon_2_2 _anon_3_2 payload_len2_2 payload_len8_2 _anon_4_2 masking_key_2 chunk_2 (field 'first_frame', id n/a, parser, args: (self));
        ::hilti::rt::optional::valueOrInit((*__self).first_frame) = (__hlt_websocket::WebSocket::Frame(__self));
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).first_frame)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: WebSocket__Frame_2 -> _anon_7 _anon_2_2 _anon_3_2 payload_len2_2 payload_len8_2 _anon_4_2 masking_key_2 chunk_2 (field 'first_frame', id n/a, parser, args: (self));

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:101:3-104:3");
        (*__self).__on_first_frame(::hilti::rt::optional::value((*__self).first_frame));
        __error = (*__self).__error;
    }

    ::hilti::rt::Vector<__hlt_websocket::WebSocket::Frame> __transient__anon_8;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:106:3-108:3");
    ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    if ( ! ((*__self).done) ) {
        // Begin parsing production: ForEach: _anon_8 -> foreach: Resolved_4;
        std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse__anon_8_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, __transient__anon_8);
        // End parsing production: ForEach: _anon_8 -> foreach: Resolved_4;

        ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }

    ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::CloseFrame> __transient__anon_9;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:80:19-90:1");
    if ( ::hilti::rt::integer::safe<uint64_t>((*__self).opcode) == __hlt_websocket::WebSocket::OPCODE_CLOSE ) {
        ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
        ::hilti::rt::stream::SafeConstIterator __parse_lahe;
        ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*::hilti::rt::optional::value((*__self).first_frame)).close_data);
        (*__parse_from).freeze();
        ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
        ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

        // Begin parsing production: Unit: WebSocket__CloseFrame_2 -> _anon_6_2;
        __transient__anon_9 = (__hlt_websocket::WebSocket::CloseFrame());
        std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*__transient__anon_9).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
        // End parsing production: Unit: WebSocket__CloseFrame_2 -> _anon_6_2;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::Message::__parse__anon_8_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_websocket::WebSocket::Frame>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_5;
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:106:3-108:3");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_5=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_6;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:21:14-78:1");

        // Begin parsing production: Unit: WebSocket__Frame_2 -> _anon_7 _anon_2_2 _anon_3_2 payload_len2_2 payload_len8_2 _anon_4_2 masking_key_2 chunk_2 (field 'first_frame', id n/a, parser, args: (self));
        __elem = (__hlt_websocket::WebSocket::Frame(__self));
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: WebSocket__Frame_2 -> _anon_7 _anon_2_2 _anon_3_2 payload_len2_2 payload_len8_2 _anon_4_2 masking_key_2 chunk_2 (field 'first_frame', id n/a, parser, args: (self));

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);

        {
            ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame> __dd = __elem;
            __stop = (__stop) || (((*__self).done));
        }

        if ( ! (__stop) ) {
            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:106:3-108:3");
            (*__self).__on__anon_8_foreach(__elem, __stop);
            __error = (*__self).__error;
        }

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_6=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:106:3-108:3");
            throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:106:3-108:3");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::Message::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_WebSocket__Message_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_websocket::WebSocket::Message::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");
    ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message> __unit = ::hilti::rt::reference::make_value<__hlt_websocket::WebSocket::Message>((__hlt_websocket::WebSocket::Message()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");

    // Begin parsing production: Unit: WebSocket__Message -> Resolved_4 _anon_8 Resolved_5;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: WebSocket__Message -> Resolved_4 _anon_8 Resolved_5;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_websocket::WebSocket::Message::parse2(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");

    // Begin parsing production: Unit: WebSocket__Message -> Resolved_4 _anon_8 Resolved_5;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: WebSocket__Message -> Resolved_4 _anon_8 Resolved_5;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_websocket::WebSocket::Message::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");
    ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message> __unit = ::hilti::rt::reference::make_value<__hlt_websocket::WebSocket::Message>((__hlt_websocket::WebSocket::Message()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_WebSocket__Message_namex2aWebSocket__Messagex2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");

    // Begin parsing production: Unit: WebSocket__Message -> Resolved_4 _anon_8 Resolved_5;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: WebSocket__Message -> Resolved_4 _anon_8 Resolved_5;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_websocket::WebSocket::Messages::__parse_WebSocket__Messages_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Messages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Vector<__hlt_websocket::WebSocket::Message> __transient__anon_11;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:118:3-118:14");
    ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

    // Begin parsing production: While: _anon_11 -> while(<look-ahead-found>): Resolved_7;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse__anon_11_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, __transient__anon_11);
    // End parsing production: While: _anon_11 -> while(<look-ahead-found>): Resolved_7;

    ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::Messages::__parse__anon_11_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_websocket::WebSocket::Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Messages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:118:3-118:14");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ::hilti::rt::Bool(true) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_7;
        ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_7=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_8;
            if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_8=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
            }
            else {
            }
        }

        if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
            break;
        }

        else  {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_9;
            ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
            ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message> __elem;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:93:23-115:1");

            // Begin parsing production: Unit: WebSocket__Message_2 -> Resolved_8 _anon_8_2 Resolved_9 (container '_anon_11');
            __elem = (__hlt_websocket::WebSocket::Message());
            std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: WebSocket__Message_2 -> Resolved_8 _anon_8_2 Resolved_9 (container '_anon_11');

            ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
            if ( ! (__stop) ) {
            }

            if ( __stop ) {
                break;
            }

            if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_9=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:118:3-118:14");
                throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:118:3-118:14");
            }
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_websocket::WebSocket::Messages::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Messages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_WebSocket__Messages_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_websocket::WebSocket::Messages::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");
    ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Messages> __unit = ::hilti::rt::reference::make_value<__hlt_websocket::WebSocket::Messages>((__hlt_websocket::WebSocket::Messages()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");

    // Begin parsing production: Unit: WebSocket__Messages -> _anon_11;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: WebSocket__Messages -> _anon_11;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_websocket::WebSocket::Messages::parse2(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");

    // Begin parsing production: Unit: WebSocket__Messages -> _anon_11;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: WebSocket__Messages -> _anon_11;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_websocket::WebSocket::Messages::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");
    ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Messages> __unit = ::hilti::rt::reference::make_value<__hlt_websocket::WebSocket::Messages>((__hlt_websocket::WebSocket::Messages()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_WebSocket__Messages_namex2aWebSocket__Messagesx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:117:24-119:1");

    // Begin parsing production: Unit: WebSocket__Messages -> _anon_11;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: WebSocket__Messages -> _anon_11;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern void __hlt_websocket::WebSocket::__hook_CloseFrame___on__anon_6_8edc(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CloseFrame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:85:5-88:5");
    if ( __dd.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:86:7-86:81");
        (*__self).status = static_cast<::hilti::rt::integer::safe<uint16_t>>(__dd.sub(::hilti::rt::integer::safe<std::uint64_t>{0U}, ::hilti::rt::integer::safe<std::uint64_t>{2U}).toUInt(::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:87:7-87:32");
        (*__self).reason = __dd.sub(::hilti::rt::integer::safe<std::uint64_t>{2U}, ::hilti::rt::integer::safe<std::uint64_t>{0U});
    }
}

extern void __hlt_websocket::WebSocket::__hook_Frame___on__anon_3_8934(::hilti::rt::ValueReference<Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:41:5-41:84");
    (*__self).effective_opcode = (::hilti::rt::integer::safe<uint64_t>((*__self->__p_m.derefAsValue()).opcode) != __hlt_websocket::WebSocket::OPCODE_CONTINUATION ? (*__self->__p_m.derefAsValue()).opcode : (::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self)._anon).value))));
}

extern void __hlt_websocket::WebSocket::__hook_Frame___on__anon_4_1eca(::hilti::rt::ValueReference<Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:48:5-48:40");
    (*__self).payload_len = ::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<4>(::hilti::rt::optional::value((*__self)._anon).value))));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:49:5-52:43");
    if ( (*__self).payload_len2.has_value() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:50:7-50:42");
        (*__self).payload_len = ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).payload_len2));
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:51:10-52:43");
        if ( (*__self).payload_len8.has_value() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:52:7-52:42");
            (*__self).payload_len = ::hilti::rt::optional::value((*__self).payload_len8);
        }
    }
}

extern void __hlt_websocket::WebSocket::__hook_Frame___on_chunk_1151(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:62:5-67:5");
    if ( (::hilti::rt::optional::value(std::get<3>(::hilti::rt::optional::value((*__self)._anon).value))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:63:7-63:74");
        ::hilti::rt::optional::valueOrInit((*__self).chunk) = ::hlt_websocket::WebSocket::fast_unmask((*__self).masking_key_idx, ::hilti::rt::optional::value((*__self).masking_key), __dd);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:64:7-64:34");
        (*__self).masking_key_idx += __dd.size();
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:66:7-66:21");
        ::hilti::rt::optional::valueOrInit((*__self).chunk) = __dd;
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:70:5-71:50");
    if ( (::hilti::rt::integer::safe<uint64_t>((*__self).effective_opcode) == __hlt_websocket::WebSocket::OPCODE_TEXT) || (::hilti::rt::integer::safe<uint64_t>((*__self).effective_opcode) == __hlt_websocket::WebSocket::OPCODE_BINARY) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:71:7-71:49");
        ::zeek::spicy::rt::protocol_data_in(::zeek::spicy::rt::is_orig(), __dd, ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP});
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:75:5-76:28");
    if ( ::hilti::rt::integer::safe<uint64_t>((*__self).effective_opcode) == __hlt_websocket::WebSocket::OPCODE_CLOSE ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:76:7-76:27");
        (*__self).close_data.append(__dd);
    }
}

extern void __hlt_websocket::WebSocket::__hook_Message___on_0x25_done_74cc(::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:113:5-113:25");
    ::spicy::rt::accept_input();
}

extern void __hlt_websocket::WebSocket::__hook_Message___on__anon_8_foreach_ca51(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:107:5-107:22");
    (*__self).done = (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__dd)._anon).value)));
}

extern void __hlt_websocket::WebSocket::__hook_Message___on_first_frame_c21(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:102:5-102:27");
    (*__self).opcode = (::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__dd)._anon).value)));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.spicy:103:5-103:22");
    (*__self).done = (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__dd)._anon).value)));
}

extern void __hlt_websocket::WebSocket::__init_module() {
    __hlt_websocket::WebSocket::__register_WebSocket_CloseFrame();
    __hlt_websocket::WebSocket::__register_WebSocket_Frame();
    __hlt_websocket::WebSocket::__register_WebSocket_Message();
    __hlt_websocket::WebSocket::__register_WebSocket_Messages();
}

extern void __hlt_websocket::WebSocket::__register_WebSocket_CloseFrame() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_websocket::WebSocket::__register_WebSocket_Frame() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_websocket::WebSocket::__register_WebSocket_Message() {
    ::hilti::rt::detail::checkStack();
    WebSocket::Message::__parser = ::spicy::rt::Parser("WebSocket::Message"sv, ::hilti::rt::Bool(true), hlt_websocket::WebSocket::Message::parse1, hlt_websocket::WebSocket::Message::parse2, hlt_websocket::WebSocket::Message::parse3, ::hilti::rt::Null(), &type_info::__ti_WebSocket__Message_namex2aWebSocket__Messagex2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(WebSocket::Message::__parser, std::string(__hlt_websocket_hlto_scope), ::hilti::rt::StrongReference<__hlt_websocket::WebSocket::Message>());
}

extern void __hlt_websocket::WebSocket::__register_WebSocket_Messages() {
    ::hilti::rt::detail::checkStack();
    WebSocket::Messages::__parser = ::spicy::rt::Parser("WebSocket::Messages"sv, ::hilti::rt::Bool(true), hlt_websocket::WebSocket::Messages::parse1, hlt_websocket::WebSocket::Messages::parse2, hlt_websocket::WebSocket::Messages::parse3, ::hilti::rt::Null(), &type_info::__ti_WebSocket__Messages_namex2aWebSocket__Messagesx2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(WebSocket::Messages::__parser, std::string(__hlt_websocket_hlto_scope), ::hilti::rt::StrongReference<__hlt_websocket::WebSocket::Messages>());
}

extern void __hlt_websocket::WebSocket::__register_module() { ::hilti::rt::detail::registerModule({ "WebSocket", __hlt_websocket_hlto_scope, &__init_module, nullptr, nullptr, nullptr}); }

extern auto __hlt_websocket::WebSocket::operator<<(std::ostream& o, const __hlt_websocket::WebSocket::CloseFrame& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_websocket::WebSocket::operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Message& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_websocket::WebSocket::operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Frame& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_websocket::WebSocket::operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Messages& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto hlt_websocket::WebSocket::Message::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_websocket::WebSocket::Message::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_websocket::WebSocket::Message::parse2(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_websocket::WebSocket::Message::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_websocket::WebSocket::Message::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_websocket::WebSocket::Message::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_websocket::WebSocket::Messages::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_websocket::WebSocket::Messages::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_websocket::WebSocket::Messages::parse2(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_websocket::WebSocket::Messages::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_websocket::WebSocket::Messages::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_websocket::WebSocket::Messages::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

