// Begin of spicy_hooks_Finger (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_finger_hlto_scope;

namespace __hlt_finger::Finger {
    struct ReplyLine;
    struct Request;
    struct ReplyLine : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ReplyLine> {
        auto __self() { return ::hilti::rt::ValueReference<ReplyLine>::self(this); }
        std::optional<std::string> data{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Finger__ReplyLine_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ReplyLine();
        ReplyLine(const ReplyLine&) = default;
        ReplyLine(ReplyLine&&) = default;
        ReplyLine& operator=(const ReplyLine&) = default;
        ReplyLine& operator=(ReplyLine&&) = default;
        ReplyLine(std::optional<std::optional<std::string>> data);
        template<typename F> void __visit(F _) const { _("data", data); }
    };

    struct Request : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Request> {
        auto __self() { return ::hilti::rt::ValueReference<Request>::self(this); }
        void __on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures);
        std::optional<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>> arg{};
        void __on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures);
        std::string user{};
        std::string host{};
        ::hilti::rt::Bool whois{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Request>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Finger__Request_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Request();
        Request(const Request&) = default;
        Request(Request&&) = default;
        Request& operator=(const Request&) = default;
        Request& operator=(Request&&) = default;
        Request(std::optional<std::optional<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>>> arg, std::optional<std::string> user, std::optional<std::string> host, std::optional<::hilti::rt::Bool> whois);
        template<typename F> void __visit(F _) const { _("arg", arg); _("user", user); _("host", host); _("whois", whois); }
    };

}

namespace __hlt_finger::spicy_hooks_Finger {
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_finger_reply_8539db6315cf42ff = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_finger_request_7094116101cbc551 = {};
}

namespace __hlt_finger::Finger {
    extern auto operator<<(std::ostream& o, const __hlt_finger::Finger::ReplyLine& x) -> std::ostream&;
    extern void __hook_ReplyLine___on_0x25_done(::hilti::rt::ValueReference<__hlt_finger::Finger::ReplyLine>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_finger::Finger::Request& x) -> std::ostream&;
    extern void __hook_Request___on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __self);
    extern void __hook_Request___on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __self);
    extern void __hook_Request___on_0x25_done(::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __self);
}

namespace __hlt_finger::spicy_hooks_Finger {
    extern void __hook_ReplyLine___on_0x25_done_9fc1(::hilti::rt::ValueReference<Finger::ReplyLine>& __self);
}

namespace __hlt_finger::Finger {
    extern void __hook_ReplyLine___on_0x25_done(::hilti::rt::ValueReference<Finger::ReplyLine>& __self);
}

namespace __hlt_finger::spicy_hooks_Finger {
    extern void __hook_ReplyLine___on_0x25_done_9fc1(::hilti::rt::ValueReference<Finger::ReplyLine>& __self);
    extern void __hook_Request___on_0x25_done_8bcc(::hilti::rt::ValueReference<Finger::Request>& __self);
}

namespace __hlt_finger::Finger {
    extern void __hook_Request___on_0x25_done(::hilti::rt::ValueReference<Finger::Request>& __self);
}

namespace __hlt_finger::spicy_hooks_Finger {
    extern void __hook_Request___on_0x25_done_8bcc(::hilti::rt::ValueReference<Finger::Request>& __self);
    extern void __init_globals(::hilti::rt::Context* ctx);
    extern void __destroy_globals(::hilti::rt::Context* ctx);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_finger::spicy_hooks_Finger::__register_module)

inline void __hlt_finger::Finger::ReplyLine::__on_0x25_done() {
    auto __self = Finger::ReplyLine::__self();
    return __hlt_finger::Finger::__hook_ReplyLine___on_0x25_done(__self);
}

inline void __hlt_finger::Finger::Request::__on_0x25_done() {
    auto __self = Finger::Request::__self();
    return __hlt_finger::Finger::__hook_Request___on_0x25_done(__self);
}

inline void __hlt_finger::Finger::Request::__on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures) {
    auto __self = Finger::Request::__self();
    return __hlt_finger::Finger::__hook_Request___on__anon_2(__dd, __captures, __self);
}

inline void __hlt_finger::Finger::Request::__on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures) {
    auto __self = Finger::Request::__self();
    return __hlt_finger::Finger::__hook_Request___on_arg(__dd, __captures, __self);
}

extern void __hlt_finger::spicy_hooks_Finger::__destroy_globals(::hilti::rt::Context* ctx) {
    ::__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_reply_8539db6315cf42ff.reset();;
    ::__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551.reset();;
}

extern void __hlt_finger::spicy_hooks_Finger::__hook_ReplyLine___on_0x25_done_9fc1(::hilti::rt::ValueReference<Finger::ReplyLine>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:13");
    if ( ! (::hilti::rt::string::size(::hilti::rt::optional::value((*__self).data)) != ::hilti::rt::integer::safe<std::uint64_t>{0U}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:13");
        return;
    }

    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_reply_8539db6315cf42ff))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:13");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:13");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{2U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).data), ::zeek::spicy::rt::event_arg_type((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_reply_8539db6315cf42ff), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    ::zeek::spicy::rt::raise_event((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_reply_8539db6315cf42ff), std::move(args));
}

extern void __hlt_finger::spicy_hooks_Finger::__hook_Request___on_0x25_done_8bcc(::hilti::rt::ValueReference<Finger::Request>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:12");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:12");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.evt:12");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{4U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).whois, ::zeek::spicy::rt::event_arg_type((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).user, ::zeek::spicy::rt::event_arg_type((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).host, ::zeek::spicy::rt::event_arg_type((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    ::zeek::spicy::rt::raise_event((*__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551), std::move(args));
}

extern void __hlt_finger::spicy_hooks_Finger::__init_globals(::hilti::rt::Context* ctx) {
    ::__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_reply_8539db6315cf42ff = ::zeek::spicy::rt::internal_handler("finger_reply"s);
    ::__hlt_finger::spicy_hooks_Finger::__zeek_handler_finger_request_7094116101cbc551 = ::zeek::spicy::rt::internal_handler("finger_request"s);
}

extern void __hlt_finger::spicy_hooks_Finger::__register_module() { ::hilti::rt::detail::registerModule({ "spicy_hooks_Finger", __hlt_finger_hlto_scope, nullptr, &__init_globals, &__destroy_globals, nullptr}); }
