// Begin of spicy_hooks_LDAP (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_ldap_hlto_scope;

namespace __hlt_ldap::ASN1 {
    struct ASN1BitString;
    struct ASN1Tag;
    struct LengthType;
    struct ASN1Header;
    struct ASN1SubMessages;
    struct ASN1Message;
    struct ASN1Body;
    struct ASN1ObjectIdentifier;
}

namespace __hlt_ldap::LDAP {
    struct Ctx;
    struct GSS_SPNEGO_negTokenInit;
    struct GSS_SPNEGO_Init;
    struct GSS_SPNEGO_negTokenResp;
    struct GSS_SPNEGO_Subsequent;
    struct Result;
    struct SaslCredentials;
    struct ServerSaslCreds;
    struct UnbindRequest;
    struct SearchResultEntry;
    struct SearchResultDone;
    struct SearchRequest;
    struct NotImplemented;
    struct ModifyResponse;
    struct ModifyRequest;
    struct ModDNResponse;
    struct Message;
    struct ExtendedResponseEntry;
    struct ExtendedResponse;
    struct ExtendedRequest;
    struct DelResponse;
    struct DelRequest;
    struct CompareResponse;
    struct BindResponse;
    struct BindRequest;
    struct AddResponse;
    struct AbandonRequest;
}

namespace __hlt_ldap::ASN1 {
    HILTI_RT_ENUM_WITH_DEFAULT(ASN1Class, Undef, Universal = 0, Application = 1, ContextSpecific = 2, Private = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ASN1Type, Undef, Boolean = 1, Integer = 2, BitString = 3, OctetString = 4, NullVal = 5, ObjectIdentifier = 6, ObjectDescriptor = 7, InstanceOf = 8, Real = 9, Enumerated = 10, EmbeddedPDV = 11, UTF8String = 12, RelativeOID = 13, Sequence = 16, Set = 17, NumericString = 18, PrintableString = 19, TeletextString = 20, VideotextString = 21, IA5String = 22, UTCTime = 23, GeneralizedTime = 24, GraphicString = 25, VisibleString = 26, GeneralString = 27, UniversalString = 28, CharacterString = 29, BMPString = 30, Undef = -1);;
}

namespace __hlt_ldap::LDAP {
    HILTI_RT_ENUM_WITH_DEFAULT(BindAuthType, Undef, BIND_AUTH_SIMPLE = 0, BIND_AUTH_SASL = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(MessageMode, Undef, MS_KRB5 = 1, TLS = 2, MAYBE_ENCRYPTED = 3, CLEARTEXT = 4, ENCRYPTED = 5, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ProtocolOpcode, Undef, BIND_REQUEST = 0, BIND_RESPONSE = 1, UNBIND_REQUEST = 2, SEARCH_REQUEST = 3, SEARCH_RESULT_ENTRY = 4, SEARCH_RESULT_DONE = 5, MODIFY_REQUEST = 6, MODIFY_RESPONSE = 7, ADD_REQUEST = 8, ADD_RESPONSE = 9, DEL_REQUEST = 10, DEL_RESPONSE = 11, MOD_DN_REQUEST = 12, MOD_DN_RESPONSE = 13, COMPARE_REQUEST = 14, COMPARE_RESPONSE = 15, ABANDON_REQUEST = 16, SEARCH_RESULT_REFERENCE = 19, EXTENDED_REQUEST = 23, EXTENDED_RESPONSE = 24, INTERMEDIATE_RESPONSE = 25, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ResultCode, Undef, SUCCESS = 0, OPERATIONS_ERROR = 1, PROTOCOL_ERROR = 2, TIME_LIMIT_EXCEEDED = 3, SIZE_LIMIT_EXCEEDED = 4, COMPARE_FALSE = 5, COMPARE_TRUE = 6, AUTH_METHOD_NOT_SUPPORTED = 7, STRONGER_AUTH_REQUIRED = 8, PARTIAL_RESULTS = 9, REFERRAL = 10, ADMIN_LIMIT_EXCEEDED = 11, UNAVAILABLE_CRITICAL_EXTENSION = 12, CONFIDENTIALITY_REQUIRED = 13, SASL_BIND_IN_PROGRESS = 14, NO_SUCH_ATTRIBUTE = 16, UNDEFINED_ATTRIBUTE_TYPE = 17, INAPPROPRIATE_MATCHING = 18, CONSTRAINT_VIOLATION = 19, ATTRIBUTE_OR_VALUE_EXISTS = 20, INVALID_ATTRIBUTE_SYNTAX = 21, NO_SUCH_OBJECT = 32, ALIAS_PROBLEM = 33, INVALID_DNSYNTAX = 34, ALIAS_DEREFERENCING_PROBLEM = 36, INAPPROPRIATE_AUTHENTICATION = 48, INVALID_CREDENTIALS = 49, INSUFFICIENT_ACCESS_RIGHTS = 50, BUSY = 51, UNAVAILABLE = 52, UNWILLING_TO_PERFORM = 53, LOOP_DETECT = 54, SORT_CONTROL_MISSING = 60, OFFSET_RANGE_ERROR = 61, NAMING_VIOLATION = 64, OBJECT_CLASS_VIOLATION = 65, NOT_ALLOWED_ON_NON_LEAF = 66, NOT_ALLOWED_ON_RDN = 67, ENTRY_ALREADY_EXISTS = 68, OBJECT_CLASS_MODS_PROHIBITED = 69, RESULTS_TOO_LARGE = 70, AFFECTS_MULTIPLE_DSAS = 71, CONTROL_ERROR = 76, OTHER = 80, SERVER_DOWN = 81, LOCAL_ERROR = 82, ENCODING_ERROR = 83, DECODING_ERROR = 84, TIMEOUT = 85, AUTH_UNKNOWN = 86, FILTER_ERROR = 87, USER_CANCELED = 88, PARAM_ERROR = 89, NO_MEMORY = 90, CONNECT_ERROR = 91, NOT_SUPPORTED = 92, CONTROL_NOT_FOUND = 93, NO_RESULTS_RETURNED = 94, MORE_RESULTS_TO_RETURN = 95, CLIENT_LOOP = 96, REFERRAL_LIMIT_EXCEEDED = 97, INVALID_RESPONSE = 100, AMBIGUOUS_RESPONSE = 101, TLS_NOT_SUPPORTED = 112, INTERMEDIATE_RESPONSE = 113, UNKNOWN_TYPE = 114, LCUP_INVALID_DATA = 115, LCUP_UNSUPPORTED_SCHEME = 116, LCUP_RELOAD_REQUIRED = 117, CANCELED = 118, NO_SUCH_OPERATION = 119, TOO_LATE = 120, CANNOT_CANCEL = 121, ASSERTION_FAILED = 122, AUTHORIZATION_DENIED = 123, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(SearchDerefAlias, Undef, DEREF_NEVER = 0, DEREF_IN_SEARCHING = 1, DEREF_FINDING_BASE = 2, DEREF_ALWAYS = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(SearchScope, Undef, SEARCH_BASE = 0, SEARCH_SINGLE = 1, SEARCH_TREE = 2, Undef = -1);;
}

namespace __hlt_ldap::ASN1 {
    struct ASN1BitString : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1BitString> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1BitString>::self(this); }
        std::optional<::hilti::rt::Bytes> value_bits{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1BitString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ::hilti::rt::Bool __p_constructed{};
        ASN1BitString();
        ASN1BitString(const ASN1BitString&) = default;
        ASN1BitString(ASN1BitString&&) = default;
        ASN1BitString& operator=(const ASN1BitString&) = default;
        ASN1BitString& operator=(ASN1BitString&&) = default;
        ASN1BitString(std::optional<std::optional<::hilti::rt::Bytes>> value_bits);
        ASN1BitString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed);
        template<typename F> void __visit(F _) const { _("value_bits", value_bits); }
    };

    struct ASN1Tag : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1Tag> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Tag>::self(this); }
        std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>> _anon_46{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Tag_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1Tag();
        ASN1Tag(const ASN1Tag&) = default;
        ASN1Tag(ASN1Tag&&) = default;
        ASN1Tag& operator=(const ASN1Tag&) = default;
        ASN1Tag& operator=(ASN1Tag&&) = default;
        ASN1Tag(std::optional<std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>>> _anon_46);
        template<typename F> void __visit(F _) const { _("<anon>", _anon_46); }
    };

    struct LengthType : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<LengthType> {
        auto __self() { return ::hilti::rt::ValueReference<LengthType>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> len{};
        ::hilti::rt::integer::safe<uint8_t> tag_len{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> data{};
        void __on__anon_44();
        void __on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_152_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__LengthType_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        LengthType();
        LengthType(const LengthType&) = default;
        LengthType(LengthType&&) = default;
        LengthType& operator=(const LengthType&) = default;
        LengthType& operator=(LengthType&&) = default;
        LengthType(std::optional<::hilti::rt::integer::safe<uint64_t>> len, std::optional<::hilti::rt::integer::safe<uint8_t>> tag_len, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> data);
        template<typename F> void __visit(F _) const { _("len", len); _("tag_len", tag_len); _("data", data); }
    };

    struct ASN1Header : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1Header> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Header>::self(this); }
        std::optional<::hilti::rt::ValueReference<ASN1Tag>> tag{};
        std::optional<::hilti::rt::ValueReference<LengthType>> len{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<ASN1Header>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_ASN1__ASN1Header_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1Header();
        ASN1Header(const ASN1Header&) = default;
        ASN1Header(ASN1Header&&) = default;
        ASN1Header& operator=(const ASN1Header&) = default;
        ASN1Header& operator=(ASN1Header&&) = default;
        ASN1Header(std::optional<std::optional<::hilti::rt::ValueReference<ASN1Tag>>> tag, std::optional<std::optional<::hilti::rt::ValueReference<LengthType>>> len);
        template<typename F> void __visit(F _) const { _("tag", tag); _("len", len); }
    };

    struct ASN1SubMessages : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1SubMessages> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1SubMessages>::self(this); }
        std::optional<::hilti::rt::Vector<ASN1Message>> submessages{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1SubMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_submessages_33_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ASN1Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1SubMessages_33_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_msgLen{};
        ASN1SubMessages();
        ASN1SubMessages(const ASN1SubMessages&) = default;
        ASN1SubMessages(ASN1SubMessages&&) = default;
        ASN1SubMessages& operator=(const ASN1SubMessages&) = default;
        ASN1SubMessages& operator=(ASN1SubMessages&&) = default;
        ASN1SubMessages(std::optional<std::optional<::hilti::rt::Vector<ASN1Message>>> submessages);
        ASN1SubMessages(const ::hilti::rt::integer::safe<uint64_t>& __p_msgLen);
        template<typename F> void __visit(F _) const { _("submessages", submessages); }
    };

    struct ASN1Message : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1Message> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Message>::self(this); }
        ::hilti::rt::integer::safe<int32_t> application_id{};
        std::optional<::hilti::rt::ValueReference<ASN1Header>> head{};
        std::optional<::hilti::rt::ValueReference<ASN1Body>> body{};
        std::optional<::hilti::rt::Bytes> application_data{};
        void __on_application_data(const ::hilti::rt::Bytes& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_161_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Message_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::Bool __p_recursive{};
        ASN1Message();
        ASN1Message(const ASN1Message&) = default;
        ASN1Message(ASN1Message&&) = default;
        ASN1Message& operator=(const ASN1Message&) = default;
        ASN1Message& operator=(ASN1Message&&) = default;
        ASN1Message(std::optional<::hilti::rt::integer::safe<int32_t>> application_id, std::optional<std::optional<::hilti::rt::ValueReference<ASN1Header>>> head, std::optional<std::optional<::hilti::rt::ValueReference<ASN1Body>>> body, std::optional<std::optional<::hilti::rt::Bytes>> application_data);
        ASN1Message(const ::hilti::rt::Bool& __p_recursive);
        template<typename F> void __visit(F _) const { _("application_id", application_id); _("head", head); _("body", body); _("application_data", application_data); }
    };

    struct ASN1Body : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1Body> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Body>::self(this); }
        std::optional<::hilti::rt::Bool> bool_value{};
        std::optional<::hilti::rt::integer::safe<int64_t>> num_value{};
        std::optional<::hilti::rt::Bytes> null_value{};
        std::optional<::hilti::rt::ValueReference<ASN1BitString>> bitstr_value{};
        std::optional<std::string> str_value{};
        std::optional<::hilti::rt::ValueReference<ASN1SubMessages>> seq{};
        std::optional<::hilti::rt::Bytes> unimplemented_value{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1Body>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_154_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Body_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<ASN1Header> __p_head{};
        ::hilti::rt::Bool __p_recursive{};
        ASN1Body();
        ASN1Body(const ASN1Body&) = default;
        ASN1Body(ASN1Body&&) = default;
        ASN1Body& operator=(const ASN1Body&) = default;
        ASN1Body& operator=(ASN1Body&&) = default;
        ASN1Body(std::optional<std::optional<::hilti::rt::Bool>> bool_value, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> num_value, std::optional<std::optional<::hilti::rt::Bytes>> null_value, std::optional<std::optional<::hilti::rt::ValueReference<ASN1BitString>>> bitstr_value, std::optional<std::optional<std::string>> str_value, std::optional<std::optional<::hilti::rt::ValueReference<ASN1SubMessages>>> seq, std::optional<std::optional<::hilti::rt::Bytes>> unimplemented_value);
        ASN1Body(const ::hilti::rt::ValueReference<ASN1Header>& __p_head, const ::hilti::rt::Bool& __p_recursive);
        template<typename F> void __visit(F _) const { _("bool_value", bool_value); _("num_value", num_value); _("null_value", null_value); _("bitstr_value", bitstr_value); _("str_value", str_value); _("seq", seq); _("unimplemented_value", unimplemented_value); }
    };

    struct ASN1ObjectIdentifier : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1ObjectIdentifier> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1ObjectIdentifier>::self(this); }
        ::hilti::rt::Bytes oidbytes{};
        ::hilti::rt::integer::safe<uint64_t> temp{};
        std::string oidstring{};
        void __on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> sublist{};
        void __on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop);
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> _anon_50{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> _anon_49{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_sublist_34_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1ObjectIdentifier_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ASN1ObjectIdentifier();
        ASN1ObjectIdentifier(const ASN1ObjectIdentifier&) = default;
        ASN1ObjectIdentifier(ASN1ObjectIdentifier&&) = default;
        ASN1ObjectIdentifier& operator=(const ASN1ObjectIdentifier&) = default;
        ASN1ObjectIdentifier& operator=(ASN1ObjectIdentifier&&) = default;
        ASN1ObjectIdentifier(std::optional<::hilti::rt::Bytes> oidbytes, std::optional<::hilti::rt::integer::safe<uint64_t>> temp, std::optional<std::string> oidstring, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>>> sublist, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_50, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_49);
        ASN1ObjectIdentifier(const ::hilti::rt::integer::safe<uint64_t>& __p_len);
        template<typename F> void __visit(F _) const { _("oidbytes", oidbytes); _("temp", temp); _("oidstring", oidstring); _("sublist", sublist); _("<anon>", _anon_50); _("<anon>", _anon_49); }
    };

}

namespace __hlt_ldap::LDAP {
    struct Ctx : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Ctx> {
        auto __self() { return ::hilti::rt::ValueReference<Ctx>::self(this); }
        LDAP::MessageMode messageMode{};
        std::string saslMechanism{};
        ::hilti::rt::Bool startTlsRequested{};
        Ctx();
        Ctx(const Ctx&) = default;
        Ctx(Ctx&&) = default;
        Ctx& operator=(const Ctx&) = default;
        Ctx& operator=(Ctx&&) = default;
        Ctx(std::optional<LDAP::MessageMode> messageMode, std::optional<std::string> saslMechanism, std::optional<::hilti::rt::Bool> startTlsRequested);
        template<typename F> void __visit(F _) const { _("messageMode", messageMode); _("saslMechanism", saslMechanism); _("startTlsRequested", startTlsRequested); }
    };

    struct GSS_SPNEGO_negTokenInit : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_negTokenInit> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenInit>::self(this); }
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> oidHeader{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>> oid{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_negTokenInit_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_negTokenInit();
        GSS_SPNEGO_negTokenInit(const GSS_SPNEGO_negTokenInit&) = default;
        GSS_SPNEGO_negTokenInit(GSS_SPNEGO_negTokenInit&&) = default;
        GSS_SPNEGO_negTokenInit& operator=(const GSS_SPNEGO_negTokenInit&) = default;
        GSS_SPNEGO_negTokenInit& operator=(GSS_SPNEGO_negTokenInit&&) = default;
        GSS_SPNEGO_negTokenInit(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> oidHeader, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>>> oid);
        template<typename F> void __visit(F _) const { _("oidHeader", oidHeader); _("oid", oid); }
    };

    struct GSS_SPNEGO_Init : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_Init> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_Init>::self(this); }
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> credentialsHeader{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> spnegoInitByte{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> spnegoChoiceByte{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_62_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_62_lha_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_Init_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_Init();
        GSS_SPNEGO_Init(const GSS_SPNEGO_Init&) = default;
        GSS_SPNEGO_Init(GSS_SPNEGO_Init&&) = default;
        GSS_SPNEGO_Init& operator=(const GSS_SPNEGO_Init&) = default;
        GSS_SPNEGO_Init& operator=(GSS_SPNEGO_Init&&) = default;
        GSS_SPNEGO_Init(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> credentialsHeader, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoInitByte, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoChoiceByte);
        template<typename F> void __visit(F _) const { _("credentialsHeader", credentialsHeader); _("spnegoInitByte", spnegoInitByte); _("spnegoChoiceByte", spnegoChoiceByte); }
    };

    struct GSS_SPNEGO_negTokenResp : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_negTokenResp> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>::self(this); }
        ::hilti::rt::Bool accepted{};
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> supportedMech{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> seq{};
        void __on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        std::optional<std::string> supportedMechOid{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_76_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_negTokenResp_7_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_negTokenResp();
        GSS_SPNEGO_negTokenResp(const GSS_SPNEGO_negTokenResp&) = default;
        GSS_SPNEGO_negTokenResp(GSS_SPNEGO_negTokenResp&&) = default;
        GSS_SPNEGO_negTokenResp& operator=(const GSS_SPNEGO_negTokenResp&) = default;
        GSS_SPNEGO_negTokenResp& operator=(GSS_SPNEGO_negTokenResp&&) = default;
        GSS_SPNEGO_negTokenResp(std::optional<::hilti::rt::Bool> accepted, std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> supportedMech, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>> seq, std::optional<std::optional<std::string>> supportedMechOid);
        template<typename F> void __visit(F _) const { _("accepted", accepted); _("supportedMech", supportedMech); _("seq", seq); _("supportedMechOid", supportedMechOid); }
    };

    struct GSS_SPNEGO_Subsequent : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_Subsequent> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> spnegoChoiceByte{};
        std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>> negTokenResp{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_68_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_Subsequent_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_Subsequent();
        GSS_SPNEGO_Subsequent(const GSS_SPNEGO_Subsequent&) = default;
        GSS_SPNEGO_Subsequent(GSS_SPNEGO_Subsequent&&) = default;
        GSS_SPNEGO_Subsequent& operator=(const GSS_SPNEGO_Subsequent&) = default;
        GSS_SPNEGO_Subsequent& operator=(GSS_SPNEGO_Subsequent&&) = default;
        GSS_SPNEGO_Subsequent(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoChoiceByte, std::optional<std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>>> negTokenResp);
        template<typename F> void __visit(F _) const { _("spnegoChoiceByte", spnegoChoiceByte); _("negTokenResp", negTokenResp); }
    };

    struct Result : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Result> {
        auto __self() { return ::hilti::rt::ValueReference<Result>::self(this); }
        std::optional<LDAP::ResultCode> code{};
        std::optional<std::string> matchedDN{};
        std::optional<std::string> diagnosticMessage{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Result>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_LDAP__Result_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Result();
        Result(const Result&) = default;
        Result(Result&&) = default;
        Result& operator=(const Result&) = default;
        Result& operator=(Result&&) = default;
        Result(std::optional<std::optional<LDAP::ResultCode>> code, std::optional<std::optional<std::string>> matchedDN, std::optional<std::optional<std::string>> diagnosticMessage);
        template<typename F> void __visit(F _) const { _("code", code); _("matchedDN", matchedDN); _("diagnosticMessage", diagnosticMessage); }
    };

    struct SaslCredentials : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SaslCredentials> {
        auto __self() { return ::hilti::rt::ValueReference<SaslCredentials>::self(this); }
        std::optional<std::string> mechanism{};
        std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Init>> gss_spnego{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_66_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SaslCredentials_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SaslCredentials();
        SaslCredentials(const SaslCredentials&) = default;
        SaslCredentials(SaslCredentials&&) = default;
        SaslCredentials& operator=(const SaslCredentials&) = default;
        SaslCredentials& operator=(SaslCredentials&&) = default;
        SaslCredentials(std::optional<std::optional<std::string>> mechanism, std::optional<std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Init>>> gss_spnego);
        template<typename F> void __visit(F _) const { _("mechanism", mechanism); _("gss_spnego", gss_spnego); }
    };

    struct ServerSaslCreds : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ServerSaslCreds> {
        auto __self() { return ::hilti::rt::ValueReference<ServerSaslCreds>::self(this); }
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> serverSaslCreds{};
        std::optional<::hilti::rt::Bytes> payload{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ServerSaslCreds_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ServerSaslCreds();
        ServerSaslCreds(const ServerSaslCreds&) = default;
        ServerSaslCreds(ServerSaslCreds&&) = default;
        ServerSaslCreds& operator=(const ServerSaslCreds&) = default;
        ServerSaslCreds& operator=(ServerSaslCreds&&) = default;
        ServerSaslCreds(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> serverSaslCreds, std::optional<std::optional<::hilti::rt::Bytes>> payload);
        template<typename F> void __visit(F _) const { _("serverSaslCreds", serverSaslCreds); _("payload", payload); }
    };

    struct UnbindRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<UnbindRequest> {
        auto __self() { return ::hilti::rt::ValueReference<UnbindRequest>::self(this); }
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__UnbindRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        UnbindRequest();
        UnbindRequest(const UnbindRequest&) = default;
        UnbindRequest(UnbindRequest&&) = default;
        UnbindRequest& operator=(const UnbindRequest&) = default;
        UnbindRequest& operator=(UnbindRequest&&) = default;
        UnbindRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct SearchResultEntry : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SearchResultEntry> {
        auto __self() { return ::hilti::rt::ValueReference<SearchResultEntry>::self(this); }
        std::optional<std::string> objectName{};
        void __on_objectName(const std::string& __dd);
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> attributes{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SearchResultEntry_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        SearchResultEntry();
        SearchResultEntry(const SearchResultEntry&) = default;
        SearchResultEntry(SearchResultEntry&&) = default;
        SearchResultEntry& operator=(const SearchResultEntry&) = default;
        SearchResultEntry& operator=(SearchResultEntry&&) = default;
        SearchResultEntry(std::optional<std::optional<std::string>> objectName, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>> attributes);
        SearchResultEntry(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("objectName", objectName); _("attributes", attributes); }
    };

    struct SearchResultDone : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SearchResultDone> {
        auto __self() { return ::hilti::rt::ValueReference<SearchResultDone>::self(this); }
        void __on__anon_35(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SearchResultDone_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        SearchResultDone();
        SearchResultDone(const SearchResultDone&) = default;
        SearchResultDone(SearchResultDone&&) = default;
        SearchResultDone& operator=(const SearchResultDone&) = default;
        SearchResultDone& operator=(SearchResultDone&&) = default;
        SearchResultDone(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct SearchRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SearchRequest> {
        auto __self() { return ::hilti::rt::ValueReference<SearchRequest>::self(this); }
        std::optional<std::string> baseObject{};
        void __on_baseObject(const std::string& __dd);
        std::optional<LDAP::SearchScope> scope{};
        void __on_scope(const LDAP::SearchScope& __dd);
        std::optional<LDAP::SearchDerefAlias> deref{};
        std::optional<::hilti::rt::integer::safe<int64_t>> sizeLimit{};
        std::optional<::hilti::rt::integer::safe<int64_t>> timeLimit{};
        std::optional<::hilti::rt::Bool> typesOnly{};
        std::optional<std::string> filter{};
        std::optional<::hilti::rt::Vector<std::string>> attributes{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<SearchRequest>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_LDAP__SearchRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        SearchRequest();
        SearchRequest(const SearchRequest&) = default;
        SearchRequest(SearchRequest&&) = default;
        SearchRequest& operator=(const SearchRequest&) = default;
        SearchRequest& operator=(SearchRequest&&) = default;
        SearchRequest(std::optional<std::optional<std::string>> baseObject, std::optional<std::optional<LDAP::SearchScope>> scope, std::optional<std::optional<LDAP::SearchDerefAlias>> deref, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> sizeLimit, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> timeLimit, std::optional<std::optional<::hilti::rt::Bool>> typesOnly, std::optional<std::optional<std::string>> filter, std::optional<std::optional<::hilti::rt::Vector<std::string>>> attributes);
        SearchRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("baseObject", baseObject); _("scope", scope); _("deref", deref); _("sizeLimit", sizeLimit); _("timeLimit", timeLimit); _("typesOnly", typesOnly); _("filter", filter); _("attributes", attributes); }
    };

    struct NotImplemented : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<NotImplemented> {
        auto __self() { return ::hilti::rt::ValueReference<NotImplemented>::self(this); }
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__NotImplemented_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        NotImplemented();
        NotImplemented(const NotImplemented&) = default;
        NotImplemented(NotImplemented&&) = default;
        NotImplemented& operator=(const NotImplemented&) = default;
        NotImplemented& operator=(NotImplemented&&) = default;
        NotImplemented(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct ModifyResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ModifyResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ModifyResponse>::self(this); }
        void __on__anon_36(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ModifyResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ModifyResponse();
        ModifyResponse(const ModifyResponse&) = default;
        ModifyResponse(ModifyResponse&&) = default;
        ModifyResponse& operator=(const ModifyResponse&) = default;
        ModifyResponse& operator=(ModifyResponse&&) = default;
        ModifyResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct ModifyRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ModifyRequest> {
        auto __self() { return ::hilti::rt::ValueReference<ModifyRequest>::self(this); }
        std::optional<std::string> objectName{};
        void __on_objectName(const std::string& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ModifyRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ModifyRequest();
        ModifyRequest(const ModifyRequest&) = default;
        ModifyRequest(ModifyRequest&&) = default;
        ModifyRequest& operator=(const ModifyRequest&) = default;
        ModifyRequest& operator=(ModifyRequest&&) = default;
        ModifyRequest(std::optional<std::optional<std::string>> objectName);
        ModifyRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("objectName", objectName); }
    };

    struct ModDNResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ModDNResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ModDNResponse>::self(this); }
        void __on__anon_39(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ModDNResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ModDNResponse();
        ModDNResponse(const ModDNResponse&) = default;
        ModDNResponse(ModDNResponse&&) = default;
        ModDNResponse& operator=(const ModDNResponse&) = default;
        ModDNResponse& operator=(ModDNResponse&&) = default;
        ModDNResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct Message : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<Message> {
        auto __self() { return ::hilti::rt::ValueReference<Message>::self(this); }
        ::hilti::rt::integer::safe<int64_t> messageID{};
        LDAP::ProtocolOpcode opcode{};
        ::hilti::rt::ValueReference<Result> unsetResultDefault{};
        ::hilti::rt::StrongReference<Result> result_{};
        std::string obj{};
        std::string arg{};
        ::hilti::rt::integer::safe<uint64_t> seqHeaderLen{};
        ::hilti::rt::integer::safe<uint64_t> msgLen{};
        ::hilti::rt::integer::safe<uint64_t> opLen{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> seqHeader{};
        void __on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd);
        void __on__anon_19();
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> messageID_header{};
        void __on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd);
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> protocolOp{};
        void __on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd);
        std::optional<::hilti::rt::ValueReference<BindRequest>> BIND_REQUEST{};
        std::optional<::hilti::rt::ValueReference<BindResponse>> BIND_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<UnbindRequest>> UNBIND_REQUEST{};
        std::optional<::hilti::rt::ValueReference<SearchRequest>> SEARCH_REQUEST{};
        std::optional<::hilti::rt::ValueReference<SearchResultEntry>> SEARCH_RESULT_ENTRY{};
        std::optional<::hilti::rt::ValueReference<SearchResultDone>> SEARCH_RESULT_DONE{};
        std::optional<::hilti::rt::ValueReference<ModifyRequest>> MODIFY_REQUEST{};
        std::optional<::hilti::rt::ValueReference<ModifyResponse>> MODIFY_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<AddResponse>> ADD_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<DelRequest>> DEL_REQUEST{};
        std::optional<::hilti::rt::ValueReference<DelResponse>> DEL_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<ModDNResponse>> MOD_DN_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<CompareResponse>> COMPARE_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<AbandonRequest>> ABANDON_REQUEST{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> ADD_REQUEST{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> COMPARE_REQUEST{};
        std::optional<::hilti::rt::ValueReference<ExtendedRequest>> EXTENDED_REQUEST{};
        std::optional<::hilti::rt::ValueReference<ExtendedResponse>> EXTENDED_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> INTERMEDIATE_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> MOD_DN_REQUEST{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> SEARCH_RESULT_REFERENCE{};
        void __on_0x25_done();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_54_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__Message_5_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        Message();
        Message(const Message&) = default;
        Message(Message&&) = default;
        Message& operator=(const Message&) = default;
        Message& operator=(Message&&) = default;
        Message(std::optional<::hilti::rt::integer::safe<int64_t>> messageID, std::optional<LDAP::ProtocolOpcode> opcode, std::optional<::hilti::rt::ValueReference<Result>> unsetResultDefault, std::optional<::hilti::rt::StrongReference<Result>> result_, std::optional<std::string> obj, std::optional<std::string> arg, std::optional<::hilti::rt::integer::safe<uint64_t>> seqHeaderLen, std::optional<::hilti::rt::integer::safe<uint64_t>> msgLen, std::optional<::hilti::rt::integer::safe<uint64_t>> opLen, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> seqHeader, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> messageID_header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> protocolOp, std::optional<std::optional<::hilti::rt::ValueReference<BindRequest>>> BIND_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<BindResponse>>> BIND_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<UnbindRequest>>> UNBIND_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<SearchRequest>>> SEARCH_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<SearchResultEntry>>> SEARCH_RESULT_ENTRY, std::optional<std::optional<::hilti::rt::ValueReference<SearchResultDone>>> SEARCH_RESULT_DONE, std::optional<std::optional<::hilti::rt::ValueReference<ModifyRequest>>> MODIFY_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<ModifyResponse>>> MODIFY_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<AddResponse>>> ADD_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<DelRequest>>> DEL_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<DelResponse>>> DEL_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<ModDNResponse>>> MOD_DN_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<CompareResponse>>> COMPARE_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<AbandonRequest>>> ABANDON_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> ADD_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> COMPARE_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<ExtendedRequest>>> EXTENDED_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<ExtendedResponse>>> EXTENDED_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> INTERMEDIATE_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> MOD_DN_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> SEARCH_RESULT_REFERENCE);
        Message(::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("messageID", messageID); _("opcode", opcode); _("unsetResultDefault", unsetResultDefault); _("result_", result_); _("obj", obj); _("arg", arg); _("seqHeaderLen", seqHeaderLen); _("msgLen", msgLen); _("opLen", opLen); _("seqHeader", seqHeader); _("messageID_header", messageID_header); _("protocolOp", protocolOp); _("BIND_REQUEST", BIND_REQUEST); _("BIND_RESPONSE", BIND_RESPONSE); _("UNBIND_REQUEST", UNBIND_REQUEST); _("SEARCH_REQUEST", SEARCH_REQUEST); _("SEARCH_RESULT_ENTRY", SEARCH_RESULT_ENTRY); _("SEARCH_RESULT_DONE", SEARCH_RESULT_DONE); _("MODIFY_REQUEST", MODIFY_REQUEST); _("MODIFY_RESPONSE", MODIFY_RESPONSE); _("ADD_RESPONSE", ADD_RESPONSE); _("DEL_REQUEST", DEL_REQUEST); _("DEL_RESPONSE", DEL_RESPONSE); _("MOD_DN_RESPONSE", MOD_DN_RESPONSE); _("COMPARE_RESPONSE", COMPARE_RESPONSE); _("ABANDON_REQUEST", ABANDON_REQUEST); _("ADD_REQUEST", ADD_REQUEST); _("COMPARE_REQUEST", COMPARE_REQUEST); _("EXTENDED_REQUEST", EXTENDED_REQUEST); _("EXTENDED_RESPONSE", EXTENDED_RESPONSE); _("INTERMEDIATE_RESPONSE", INTERMEDIATE_RESPONSE); _("MOD_DN_REQUEST", MOD_DN_REQUEST); _("SEARCH_RESULT_REFERENCE", SEARCH_RESULT_REFERENCE); }
    };

    struct ExtendedResponseEntry : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ExtendedResponseEntry> {
        auto __self() { return ::hilti::rt::ValueReference<ExtendedResponseEntry>::self(this); }
        void __on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ExtendedResponseEntry_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<ExtendedResponse> __p_r{};
        ExtendedResponseEntry();
        ExtendedResponseEntry(const ExtendedResponseEntry&) = default;
        ExtendedResponseEntry(ExtendedResponseEntry&&) = default;
        ExtendedResponseEntry& operator=(const ExtendedResponseEntry&) = default;
        ExtendedResponseEntry& operator=(ExtendedResponseEntry&&) = default;
        ExtendedResponseEntry(::hilti::rt::ValueReference<ExtendedResponse>& __p_r);
        template<typename F> void __visit(F _) const { }
    };

    struct ExtendedResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ExtendedResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ExtendedResponse>::self(this); }
        ::hilti::rt::Bytes responseName{};
        ::hilti::rt::Bytes responseValue{};
        void __on__anon_41(const ::hilti::rt::ValueReference<Result>& __dd);
        void __on_0x25_done();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ExtendedResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        ExtendedResponse();
        ExtendedResponse(const ExtendedResponse&) = default;
        ExtendedResponse(ExtendedResponse&&) = default;
        ExtendedResponse& operator=(const ExtendedResponse&) = default;
        ExtendedResponse& operator=(ExtendedResponse&&) = default;
        ExtendedResponse(std::optional<::hilti::rt::Bytes> responseName, std::optional<::hilti::rt::Bytes> responseValue);
        ExtendedResponse(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("responseName", responseName); _("responseValue", responseValue); }
    };

    struct ExtendedRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ExtendedRequest> {
        auto __self() { return ::hilti::rt::ValueReference<ExtendedRequest>::self(this); }
        ::hilti::rt::Bytes requestValue{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> header{};
        std::optional<std::string> requestName{};
        void __on_requestName(const std::string& __dd);
        void __on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        void __on_0x25_done();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ExtendedRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        ExtendedRequest();
        ExtendedRequest(const ExtendedRequest&) = default;
        ExtendedRequest(ExtendedRequest&&) = default;
        ExtendedRequest& operator=(const ExtendedRequest&) = default;
        ExtendedRequest& operator=(ExtendedRequest&&) = default;
        ExtendedRequest(std::optional<::hilti::rt::Bytes> requestValue, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> header, std::optional<std::optional<std::string>> requestName);
        ExtendedRequest(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("requestValue", requestValue); _("header", header); _("requestName", requestName); }
    };

    struct DelResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<DelResponse> {
        auto __self() { return ::hilti::rt::ValueReference<DelResponse>::self(this); }
        void __on__anon_38(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__DelResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        DelResponse();
        DelResponse(const DelResponse&) = default;
        DelResponse(DelResponse&&) = default;
        DelResponse& operator=(const DelResponse&) = default;
        DelResponse& operator=(DelResponse&&) = default;
        DelResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct DelRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<DelRequest> {
        auto __self() { return ::hilti::rt::ValueReference<DelRequest>::self(this); }
        std::optional<std::string> objectName{};
        void __on_objectName(const std::string& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__DelRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        DelRequest();
        DelRequest(const DelRequest&) = default;
        DelRequest(DelRequest&&) = default;
        DelRequest& operator=(const DelRequest&) = default;
        DelRequest& operator=(DelRequest&&) = default;
        DelRequest(std::optional<std::optional<std::string>> objectName);
        DelRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("objectName", objectName); }
    };

    struct CompareResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<CompareResponse> {
        auto __self() { return ::hilti::rt::ValueReference<CompareResponse>::self(this); }
        void __on__anon_40(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__CompareResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        CompareResponse();
        CompareResponse(const CompareResponse&) = default;
        CompareResponse(CompareResponse&&) = default;
        CompareResponse& operator=(const CompareResponse&) = default;
        CompareResponse& operator=(CompareResponse&&) = default;
        CompareResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct BindResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<BindResponse> {
        auto __self() { return ::hilti::rt::ValueReference<BindResponse>::self(this); }
        void __on__anon_27(const ::hilti::rt::ValueReference<Result>& __dd);
        std::optional<::hilti::rt::Vector<ServerSaslCreds>> serverSaslCreds{};
        std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>> gss_spnego{};
        void __on_gss_spnego(const ::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_serverSaslCreds_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ServerSaslCreds>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__BindResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        BindResponse();
        BindResponse(const BindResponse&) = default;
        BindResponse(BindResponse&&) = default;
        BindResponse& operator=(const BindResponse&) = default;
        BindResponse& operator=(BindResponse&&) = default;
        BindResponse(std::optional<std::optional<::hilti::rt::Vector<ServerSaslCreds>>> serverSaslCreds, std::optional<std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>>> gss_spnego);
        BindResponse(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("serverSaslCreds", serverSaslCreds); _("gss_spnego", gss_spnego); }
    };

    struct BindRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<BindRequest> {
        auto __self() { return ::hilti::rt::ValueReference<BindRequest>::self(this); }
        std::optional<::hilti::rt::integer::safe<int64_t>> version{};
        std::optional<std::string> name{};
        void __on_name(const std::string& __dd);
        LDAP::BindAuthType authType{};
        ::hilti::rt::Bytes authData{};
        std::string simpleCreds{};
        void __on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        std::optional<::hilti::rt::ValueReference<SaslCredentials>> saslCreds{};
        void __on_saslCreds(const ::hilti::rt::ValueReference<SaslCredentials>& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__BindRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        BindRequest();
        BindRequest(const BindRequest&) = default;
        BindRequest(BindRequest&&) = default;
        BindRequest& operator=(const BindRequest&) = default;
        BindRequest& operator=(BindRequest&&) = default;
        BindRequest(std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> version, std::optional<std::optional<std::string>> name, std::optional<LDAP::BindAuthType> authType, std::optional<::hilti::rt::Bytes> authData, std::optional<std::string> simpleCreds, std::optional<std::optional<::hilti::rt::ValueReference<SaslCredentials>>> saslCreds);
        BindRequest(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("version", version); _("name", name); _("authType", authType); _("authData", authData); _("simpleCreds", simpleCreds); _("saslCreds", saslCreds); }
    };

    struct AddResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<AddResponse> {
        auto __self() { return ::hilti::rt::ValueReference<AddResponse>::self(this); }
        void __on__anon_37(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__AddResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        AddResponse();
        AddResponse(const AddResponse&) = default;
        AddResponse(AddResponse&&) = default;
        AddResponse& operator=(const AddResponse&) = default;
        AddResponse& operator=(AddResponse&&) = default;
        AddResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct AbandonRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<AbandonRequest> {
        auto __self() { return ::hilti::rt::ValueReference<AbandonRequest>::self(this); }
        std::optional<::hilti::rt::integer::safe<int64_t>> messageID{};
        void __on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__AbandonRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        AbandonRequest();
        AbandonRequest(const AbandonRequest&) = default;
        AbandonRequest(AbandonRequest&&) = default;
        AbandonRequest& operator=(const AbandonRequest&) = default;
        AbandonRequest& operator=(AbandonRequest&&) = default;
        AbandonRequest(std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> messageID);
        AbandonRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("messageID", messageID); }
    };

}

namespace __hlt_ldap::spicy_hooks_LDAP {
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_bind_request_1bc8cc520dff6691 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_extended_response_c2a80d786c3eee8d = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_message_c7a92b7e586d8d61 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_starttls_4dc669759f475503 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_search_request_2acb8cc135d7c323 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_LDAP_search_result_entry_b4290081fd37cac7 = {};
}

namespace __hlt_ldap::ASN1 {
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1BitString& x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::ASN1::ASN1Class x, adl::tag) -> std::string;
}

namespace __hlt_ldap::ASN1 {
    inline auto operator<<(std::ostream& o, ASN1Class x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::ASN1::ASN1Type x, adl::tag) -> std::string;
}

namespace __hlt_ldap::ASN1 {
    inline auto operator<<(std::ostream& o, ASN1Type x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Tag& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::LengthType& x) -> std::ostream&;
    extern void __hook_LengthType___on__anon_44(::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>& __self);
    extern void __hook_LengthType___on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Header& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1SubMessages& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Message& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Body& x) -> std::ostream&;
    extern void __hook_ASN1Message___on_application_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1ObjectIdentifier& x) -> std::ostream&;
    extern void __hook_ASN1ObjectIdentifier___on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::BindAuthType x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, BindAuthType x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::MessageMode x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, MessageMode x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Ctx& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_Init& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp& x) -> std::ostream&;
    extern void __hook_GSS_SPNEGO_negTokenResp___on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_Subsequent& x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::ProtocolOpcode x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, ProtocolOpcode x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::ResultCode x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, ResultCode x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Result& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SaslCredentials& x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::SearchDerefAlias x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, SearchDerefAlias x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::SearchScope x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, SearchScope x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ServerSaslCreds& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::UnbindRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Message& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchResultEntry& x) -> std::ostream&;
    extern void __hook_SearchResultEntry___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultEntry>& __self);
    extern void __hook_SearchResultEntry___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultEntry>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchResultDone& x) -> std::ostream&;
    extern void __hook_SearchResultDone___on__anon_35(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultDone>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchRequest& x) -> std::ostream&;
    extern void __hook_SearchRequest___on_baseObject(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __self);
    extern void __hook_SearchRequest___on_scope(const LDAP::SearchScope& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __self);
    extern void __hook_SearchRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::NotImplemented& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModifyResponse& x) -> std::ostream&;
    extern void __hook_ModifyResponse___on__anon_36(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModifyRequest& x) -> std::ostream&;
    extern void __hook_ModifyRequest___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyRequest>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModDNResponse& x) -> std::ostream&;
    extern void __hook_ModDNResponse___on__anon_39(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModDNResponse>& __self);
    extern void __hook_Message___on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern void __hook_Message___on__anon_19(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern void __hook_Message___on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern void __hook_Message___on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::BindRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::BindResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::AddResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::DelRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::DelResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::CompareResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::AbandonRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedResponse& x) -> std::ostream&;
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedResponseEntry& x) -> std::ostream&;
    extern void __hook_ExtendedResponseEntry___on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponseEntry>& __self);
    extern void __hook_ExtendedResponse___on__anon_41(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>& __self);
    extern void __hook_ExtendedRequest___on_requestName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>& __self);
    extern void __hook_DelResponse___on__anon_38(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelResponse>& __self);
    extern void __hook_DelRequest___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelRequest>& __self);
    extern void __hook_CompareResponse___on__anon_40(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::CompareResponse>& __self);
    extern void __hook_BindResponse___on__anon_27(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindResponse>& __self);
    extern void __hook_BindResponse___on_gss_spnego(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindResponse>& __self);
    extern void __hook_BindRequest___on_name(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_BindRequest___on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_BindRequest___on_saslCreds(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_BindRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_AddResponse___on__anon_37(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AddResponse>& __self);
    extern void __hook_AbandonRequest___on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AbandonRequest>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_BindRequest___on_0x25_done_bd4d(::hilti::rt::ValueReference<LDAP::BindRequest>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_BindRequest___on_0x25_done(::hilti::rt::ValueReference<LDAP::BindRequest>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_BindRequest___on_0x25_done_bd4d(::hilti::rt::ValueReference<LDAP::BindRequest>& __self);
    extern void __hook_ExtendedRequest___on_0x25_done_f468(::hilti::rt::ValueReference<LDAP::ExtendedRequest>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_ExtendedRequest___on_0x25_done(::hilti::rt::ValueReference<LDAP::ExtendedRequest>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_ExtendedRequest___on_0x25_done_f468(::hilti::rt::ValueReference<LDAP::ExtendedRequest>& __self);
    extern void __hook_ExtendedResponse___on_0x25_done_9e4(::hilti::rt::ValueReference<LDAP::ExtendedResponse>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_ExtendedResponse___on_0x25_done(::hilti::rt::ValueReference<LDAP::ExtendedResponse>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_ExtendedResponse___on_0x25_done_9e4(::hilti::rt::ValueReference<LDAP::ExtendedResponse>& __self);
    extern void __hook_Message___on_0x25_done_6422(::hilti::rt::ValueReference<LDAP::Message>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<LDAP::Message>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_Message___on_0x25_done_6422(::hilti::rt::ValueReference<LDAP::Message>& __self);
    extern void __hook_Message___on_0x25_done_e34f(::hilti::rt::ValueReference<LDAP::Message>& __self);
    extern void __hook_Message___on_0x25_done_e34f(::hilti::rt::ValueReference<LDAP::Message>& __self);
    extern void __hook_SearchRequest___on_0x25_done_8bf1(::hilti::rt::ValueReference<LDAP::SearchRequest>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_SearchRequest___on_0x25_done(::hilti::rt::ValueReference<LDAP::SearchRequest>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_SearchRequest___on_0x25_done_8bf1(::hilti::rt::ValueReference<LDAP::SearchRequest>& __self);
    extern void __hook_SearchResultEntry___on_0x25_done_c729(::hilti::rt::ValueReference<LDAP::SearchResultEntry>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_SearchResultEntry___on_0x25_done(::hilti::rt::ValueReference<LDAP::SearchResultEntry>& __self);
}

namespace __hlt_ldap::spicy_hooks_LDAP {
    extern void __hook_SearchResultEntry___on_0x25_done_c729(::hilti::rt::ValueReference<LDAP::SearchResultEntry>& __self);
    extern void __init_globals(::hilti::rt::Context* ctx);
    extern void __destroy_globals(::hilti::rt::Context* ctx);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_ldap::spicy_hooks_LDAP::__register_module)

inline void __hlt_ldap::ASN1::ASN1Message::__on_application_data(const ::hilti::rt::Bytes& __dd) {
    auto __self = ASN1::ASN1Message::__self();
    return __hlt_ldap::ASN1::__hook_ASN1Message___on_application_data(__dd, __self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on_0x25_done() {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_0x25_done(__self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on__anon_48(__dd, __self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_sublist_foreach(__dd, __stop, __self);
}

inline void __hlt_ldap::ASN1::LengthType::__on__anon_44() {
    auto __self = ASN1::LengthType::__self();
    return __hlt_ldap::ASN1::__hook_LengthType___on__anon_44(__self);
}

inline void __hlt_ldap::ASN1::LengthType::__on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd) {
    auto __self = ASN1::LengthType::__self();
    return __hlt_ldap::ASN1::__hook_LengthType___on__anon_45(__dd, __self);
}

inline auto __hlt_ldap::ASN1::operator<<(std::ostream& o, ASN1Class x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::ASN1::operator<<(std::ostream& o, ASN1Type x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline void __hlt_ldap::LDAP::AbandonRequest::__on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd) {
    auto __self = LDAP::AbandonRequest::__self();
    return __hlt_ldap::LDAP::__hook_AbandonRequest___on_messageID(__dd, __self);
}

inline void __hlt_ldap::LDAP::AddResponse::__on__anon_37(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::AddResponse::__self();
    return __hlt_ldap::LDAP::__hook_AddResponse___on__anon_37(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on_0x25_done() {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on__anon_54(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on_name(const std::string& __dd) {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on_name(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on_saslCreds(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd) {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on_saslCreds(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindResponse::__on__anon_27(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::BindResponse::__self();
    return __hlt_ldap::LDAP::__hook_BindResponse___on__anon_27(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindResponse::__on_gss_spnego(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd) {
    auto __self = LDAP::BindResponse::__self();
    return __hlt_ldap::LDAP::__hook_BindResponse___on_gss_spnego(__dd, __self);
}

inline void __hlt_ldap::LDAP::CompareResponse::__on__anon_40(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::CompareResponse::__self();
    return __hlt_ldap::LDAP::__hook_CompareResponse___on__anon_40(__dd, __self);
}

inline void __hlt_ldap::LDAP::DelRequest::__on_objectName(const std::string& __dd) {
    auto __self = LDAP::DelRequest::__self();
    return __hlt_ldap::LDAP::__hook_DelRequest___on_objectName(__dd, __self);
}

inline void __hlt_ldap::LDAP::DelResponse::__on__anon_38(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::DelResponse::__self();
    return __hlt_ldap::LDAP::__hook_DelResponse___on__anon_38(__dd, __self);
}

inline void __hlt_ldap::LDAP::ExtendedRequest::__on_0x25_done() {
    auto __self = LDAP::ExtendedRequest::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedRequest___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::ExtendedRequest::__on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::ExtendedRequest::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedRequest___on__anon_59(__dd, __self);
}

inline void __hlt_ldap::LDAP::ExtendedRequest::__on_requestName(const std::string& __dd) {
    auto __self = LDAP::ExtendedRequest::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedRequest___on_requestName(__dd, __self);
}

inline void __hlt_ldap::LDAP::ExtendedResponse::__on_0x25_done() {
    auto __self = LDAP::ExtendedResponse::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedResponse___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::ExtendedResponse::__on__anon_41(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::ExtendedResponse::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedResponse___on__anon_41(__dd, __self);
}

inline void __hlt_ldap::LDAP::ExtendedResponseEntry::__on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::ExtendedResponseEntry::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedResponseEntry___on__anon_60(__dd, __self);
}

inline void __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp::__on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::GSS_SPNEGO_negTokenResp::__self();
    return __hlt_ldap::LDAP::__hook_GSS_SPNEGO_negTokenResp___on_seq(__dd, __self);
}

inline void __hlt_ldap::LDAP::Message::__on_0x25_done() {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::Message::__on__anon_19() {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on__anon_19(__self);
}

inline void __hlt_ldap::LDAP::Message::__on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd) {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on__anon_53(__dd, __self);
}

inline void __hlt_ldap::LDAP::Message::__on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd) {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on_protocolOp(__dd, __self);
}

inline void __hlt_ldap::LDAP::Message::__on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd) {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on_seqHeader(__dd, __self);
}

inline void __hlt_ldap::LDAP::ModDNResponse::__on__anon_39(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::ModDNResponse::__self();
    return __hlt_ldap::LDAP::__hook_ModDNResponse___on__anon_39(__dd, __self);
}

inline void __hlt_ldap::LDAP::ModifyRequest::__on_objectName(const std::string& __dd) {
    auto __self = LDAP::ModifyRequest::__self();
    return __hlt_ldap::LDAP::__hook_ModifyRequest___on_objectName(__dd, __self);
}

inline void __hlt_ldap::LDAP::ModifyResponse::__on__anon_36(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::ModifyResponse::__self();
    return __hlt_ldap::LDAP::__hook_ModifyResponse___on__anon_36(__dd, __self);
}

inline void __hlt_ldap::LDAP::SearchRequest::__on_0x25_done() {
    auto __self = LDAP::SearchRequest::__self();
    return __hlt_ldap::LDAP::__hook_SearchRequest___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::SearchRequest::__on_baseObject(const std::string& __dd) {
    auto __self = LDAP::SearchRequest::__self();
    return __hlt_ldap::LDAP::__hook_SearchRequest___on_baseObject(__dd, __self);
}

inline void __hlt_ldap::LDAP::SearchRequest::__on_scope(const LDAP::SearchScope& __dd) {
    auto __self = LDAP::SearchRequest::__self();
    return __hlt_ldap::LDAP::__hook_SearchRequest___on_scope(__dd, __self);
}

inline void __hlt_ldap::LDAP::SearchResultDone::__on__anon_35(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::SearchResultDone::__self();
    return __hlt_ldap::LDAP::__hook_SearchResultDone___on__anon_35(__dd, __self);
}

inline void __hlt_ldap::LDAP::SearchResultEntry::__on_0x25_done() {
    auto __self = LDAP::SearchResultEntry::__self();
    return __hlt_ldap::LDAP::__hook_SearchResultEntry___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::SearchResultEntry::__on_objectName(const std::string& __dd) {
    auto __self = LDAP::SearchResultEntry::__self();
    return __hlt_ldap::LDAP::__hook_SearchResultEntry___on_objectName(__dd, __self);
}

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, BindAuthType x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, MessageMode x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, ProtocolOpcode x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, ResultCode x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, SearchDerefAlias x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, SearchScope x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern void __hlt_ldap::spicy_hooks_LDAP::__destroy_globals(::hilti::rt::Context* ctx) {
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691.reset();;
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85.reset();;
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d.reset();;
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61.reset();;
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_starttls_4dc669759f475503.reset();;
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323.reset();;
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_result_entry_b4290081fd37cac7.reset();;
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_BindRequest___on_0x25_done_bd4d(::hilti::rt::ValueReference<LDAP::BindRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:28");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:28");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:28");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{6U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self->__p_message.derefAsValue()).messageID, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).version), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).name), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).authType, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self->__p_message.derefAsValue()).arg, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691), ::hilti::rt::integer::safe<std::uint64_t>{5U})));
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_ExtendedRequest___on_0x25_done_f468(::hilti::rt::ValueReference<LDAP::ExtendedRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:48");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:48");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:48");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{4U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self->__p_message.derefAsValue()).messageID, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).requestName), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).requestValue, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_ExtendedResponse___on_0x25_done_9e4(::hilti::rt::ValueReference<LDAP::ExtendedResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:54");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:54");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:54");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{5U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self->__p_message.derefAsValue()).messageID, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*(*__self->__p_message.derefAsValue()).result_).code.value_or(LDAP::ResultCode{LDAP::ResultCode::Undef}), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).responseName, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).responseValue, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_Message___on_0x25_done_6422(::hilti::rt::ValueReference<LDAP::Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:21");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:21");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:21");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{8U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).messageID, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).opcode, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*(*__self).result_).code.value_or(LDAP::ResultCode{LDAP::ResultCode::Undef}), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*(*__self).result_).matchedDN.value_or(""s), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*(*__self).result_).diagnosticMessage.value_or(""s), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{5U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).obj, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{6U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).arg, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), ::hilti::rt::integer::safe<std::uint64_t>{7U})));
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_Message___on_0x25_done_e34f(::hilti::rt::ValueReference<LDAP::Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:58");
    if ( ! ((*__self->__p_ctx.derefAsValue()).messageMode == LDAP::MessageMode{LDAP::MessageMode::TLS}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:58");
        return;
    }

    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_starttls_4dc669759f475503))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:58");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:58");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{1U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_starttls_4dc669759f475503), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_SearchRequest___on_0x25_done_8bf1(::hilti::rt::ValueReference<LDAP::SearchRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:39");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:39");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:39");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{10U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self->__p_message.derefAsValue()).messageID, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).baseObject), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).scope.value_or(LDAP::SearchScope{LDAP::SearchScope::Undef}), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).deref.value_or(LDAP::SearchDerefAlias{LDAP::SearchDerefAlias::Undef}), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).sizeLimit.value_or(::hilti::rt::integer::safe<std::int64_t>{0}), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{5U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).timeLimit.value_or(::hilti::rt::integer::safe<std::int64_t>{0}), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{6U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).typesOnly.value_or(::hilti::rt::Bool(false)), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{7U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).filter), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{8U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).attributes), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), ::hilti::rt::integer::safe<std::uint64_t>{9U})));
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__hook_SearchResultEntry___on_0x25_done_c729(::hilti::rt::ValueReference<LDAP::SearchResultEntry>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:43");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_result_entry_b4290081fd37cac7))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:43");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.evt:43");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self->__p_message.derefAsValue()).messageID, ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_result_entry_b4290081fd37cac7), ::hilti::rt::integer::safe<std::uint64_t>{1U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).objectName), ::zeek::spicy::rt::event_arg_type((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_result_entry_b4290081fd37cac7), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_result_entry_b4290081fd37cac7), std::move(args));
}

extern void __hlt_ldap::spicy_hooks_LDAP::__init_globals(::hilti::rt::Context* ctx) {
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_bind_request_1bc8cc520dff6691 = ::zeek::spicy::rt::internal_handler("LDAP::bind_request"s);
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_request_2ce8c1c6bdee0d85 = ::zeek::spicy::rt::internal_handler("LDAP::extended_request"s);
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_extended_response_c2a80d786c3eee8d = ::zeek::spicy::rt::internal_handler("LDAP::extended_response"s);
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_message_c7a92b7e586d8d61 = ::zeek::spicy::rt::internal_handler("LDAP::message"s);
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_starttls_4dc669759f475503 = ::zeek::spicy::rt::internal_handler("LDAP::starttls"s);
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_request_2acb8cc135d7c323 = ::zeek::spicy::rt::internal_handler("LDAP::search_request"s);
    ::__hlt_ldap::spicy_hooks_LDAP::__zeek_handler_LDAP_search_result_entry_b4290081fd37cac7 = ::zeek::spicy::rt::internal_handler("LDAP::search_result_entry"s);
}

extern void __hlt_ldap::spicy_hooks_LDAP::__register_module() { ::hilti::rt::detail::registerModule({ "spicy_hooks_LDAP", __hlt_ldap_hlto_scope, nullptr, &__init_globals, &__destroy_globals, nullptr}); }

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::ASN1::ASN1Class x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::ASN1::ASN1Class::Private: return "ASN1Class::Private";
        case __hlt_ldap::ASN1::ASN1Class::ContextSpecific: return "ASN1Class::ContextSpecific";
        case __hlt_ldap::ASN1::ASN1Class::Application: return "ASN1Class::Application";
        case __hlt_ldap::ASN1::ASN1Class::Universal: return "ASN1Class::Universal";
        case __hlt_ldap::ASN1::ASN1Class::Undef: return "ASN1Class::Undef";
        default: return ::hilti::rt::fmt("ASN1Class::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::ASN1::ASN1Type x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::ASN1::ASN1Type::BMPString: return "ASN1Type::BMPString";
        case __hlt_ldap::ASN1::ASN1Type::CharacterString: return "ASN1Type::CharacterString";
        case __hlt_ldap::ASN1::ASN1Type::UniversalString: return "ASN1Type::UniversalString";
        case __hlt_ldap::ASN1::ASN1Type::GeneralString: return "ASN1Type::GeneralString";
        case __hlt_ldap::ASN1::ASN1Type::VisibleString: return "ASN1Type::VisibleString";
        case __hlt_ldap::ASN1::ASN1Type::GraphicString: return "ASN1Type::GraphicString";
        case __hlt_ldap::ASN1::ASN1Type::GeneralizedTime: return "ASN1Type::GeneralizedTime";
        case __hlt_ldap::ASN1::ASN1Type::UTCTime: return "ASN1Type::UTCTime";
        case __hlt_ldap::ASN1::ASN1Type::IA5String: return "ASN1Type::IA5String";
        case __hlt_ldap::ASN1::ASN1Type::VideotextString: return "ASN1Type::VideotextString";
        case __hlt_ldap::ASN1::ASN1Type::TeletextString: return "ASN1Type::TeletextString";
        case __hlt_ldap::ASN1::ASN1Type::PrintableString: return "ASN1Type::PrintableString";
        case __hlt_ldap::ASN1::ASN1Type::NumericString: return "ASN1Type::NumericString";
        case __hlt_ldap::ASN1::ASN1Type::Set: return "ASN1Type::Set";
        case __hlt_ldap::ASN1::ASN1Type::Sequence: return "ASN1Type::Sequence";
        case __hlt_ldap::ASN1::ASN1Type::RelativeOID: return "ASN1Type::RelativeOID";
        case __hlt_ldap::ASN1::ASN1Type::UTF8String: return "ASN1Type::UTF8String";
        case __hlt_ldap::ASN1::ASN1Type::EmbeddedPDV: return "ASN1Type::EmbeddedPDV";
        case __hlt_ldap::ASN1::ASN1Type::Enumerated: return "ASN1Type::Enumerated";
        case __hlt_ldap::ASN1::ASN1Type::Real: return "ASN1Type::Real";
        case __hlt_ldap::ASN1::ASN1Type::InstanceOf: return "ASN1Type::InstanceOf";
        case __hlt_ldap::ASN1::ASN1Type::ObjectDescriptor: return "ASN1Type::ObjectDescriptor";
        case __hlt_ldap::ASN1::ASN1Type::ObjectIdentifier: return "ASN1Type::ObjectIdentifier";
        case __hlt_ldap::ASN1::ASN1Type::NullVal: return "ASN1Type::NullVal";
        case __hlt_ldap::ASN1::ASN1Type::OctetString: return "ASN1Type::OctetString";
        case __hlt_ldap::ASN1::ASN1Type::BitString: return "ASN1Type::BitString";
        case __hlt_ldap::ASN1::ASN1Type::Integer: return "ASN1Type::Integer";
        case __hlt_ldap::ASN1::ASN1Type::Boolean: return "ASN1Type::Boolean";
        case __hlt_ldap::ASN1::ASN1Type::Undef: return "ASN1Type::Undef";
        default: return ::hilti::rt::fmt("ASN1Type::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::BindAuthType x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::BindAuthType::BIND_AUTH_SASL: return "BindAuthType::BIND_AUTH_SASL";
        case __hlt_ldap::LDAP::BindAuthType::BIND_AUTH_SIMPLE: return "BindAuthType::BIND_AUTH_SIMPLE";
        case __hlt_ldap::LDAP::BindAuthType::Undef: return "BindAuthType::Undef";
        default: return ::hilti::rt::fmt("BindAuthType::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::MessageMode x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::MessageMode::ENCRYPTED: return "MessageMode::ENCRYPTED";
        case __hlt_ldap::LDAP::MessageMode::CLEARTEXT: return "MessageMode::CLEARTEXT";
        case __hlt_ldap::LDAP::MessageMode::MAYBE_ENCRYPTED: return "MessageMode::MAYBE_ENCRYPTED";
        case __hlt_ldap::LDAP::MessageMode::TLS: return "MessageMode::TLS";
        case __hlt_ldap::LDAP::MessageMode::MS_KRB5: return "MessageMode::MS_KRB5";
        case __hlt_ldap::LDAP::MessageMode::Undef: return "MessageMode::Undef";
        default: return ::hilti::rt::fmt("MessageMode::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::ProtocolOpcode x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::ProtocolOpcode::INTERMEDIATE_RESPONSE: return "ProtocolOpcode::INTERMEDIATE_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::EXTENDED_RESPONSE: return "ProtocolOpcode::EXTENDED_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::EXTENDED_REQUEST: return "ProtocolOpcode::EXTENDED_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_RESULT_REFERENCE: return "ProtocolOpcode::SEARCH_RESULT_REFERENCE";
        case __hlt_ldap::LDAP::ProtocolOpcode::ABANDON_REQUEST: return "ProtocolOpcode::ABANDON_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::COMPARE_RESPONSE: return "ProtocolOpcode::COMPARE_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::COMPARE_REQUEST: return "ProtocolOpcode::COMPARE_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::MOD_DN_RESPONSE: return "ProtocolOpcode::MOD_DN_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::MOD_DN_REQUEST: return "ProtocolOpcode::MOD_DN_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::DEL_RESPONSE: return "ProtocolOpcode::DEL_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::DEL_REQUEST: return "ProtocolOpcode::DEL_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::ADD_RESPONSE: return "ProtocolOpcode::ADD_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::ADD_REQUEST: return "ProtocolOpcode::ADD_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::MODIFY_RESPONSE: return "ProtocolOpcode::MODIFY_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::MODIFY_REQUEST: return "ProtocolOpcode::MODIFY_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_RESULT_DONE: return "ProtocolOpcode::SEARCH_RESULT_DONE";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_RESULT_ENTRY: return "ProtocolOpcode::SEARCH_RESULT_ENTRY";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_REQUEST: return "ProtocolOpcode::SEARCH_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::UNBIND_REQUEST: return "ProtocolOpcode::UNBIND_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::BIND_RESPONSE: return "ProtocolOpcode::BIND_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::BIND_REQUEST: return "ProtocolOpcode::BIND_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::Undef: return "ProtocolOpcode::Undef";
        default: return ::hilti::rt::fmt("ProtocolOpcode::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::ResultCode x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::ResultCode::AUTHORIZATION_DENIED: return "ResultCode::AUTHORIZATION_DENIED";
        case __hlt_ldap::LDAP::ResultCode::ASSERTION_FAILED: return "ResultCode::ASSERTION_FAILED";
        case __hlt_ldap::LDAP::ResultCode::CANNOT_CANCEL: return "ResultCode::CANNOT_CANCEL";
        case __hlt_ldap::LDAP::ResultCode::TOO_LATE: return "ResultCode::TOO_LATE";
        case __hlt_ldap::LDAP::ResultCode::NO_SUCH_OPERATION: return "ResultCode::NO_SUCH_OPERATION";
        case __hlt_ldap::LDAP::ResultCode::CANCELED: return "ResultCode::CANCELED";
        case __hlt_ldap::LDAP::ResultCode::LCUP_RELOAD_REQUIRED: return "ResultCode::LCUP_RELOAD_REQUIRED";
        case __hlt_ldap::LDAP::ResultCode::LCUP_UNSUPPORTED_SCHEME: return "ResultCode::LCUP_UNSUPPORTED_SCHEME";
        case __hlt_ldap::LDAP::ResultCode::LCUP_INVALID_DATA: return "ResultCode::LCUP_INVALID_DATA";
        case __hlt_ldap::LDAP::ResultCode::UNKNOWN_TYPE: return "ResultCode::UNKNOWN_TYPE";
        case __hlt_ldap::LDAP::ResultCode::INTERMEDIATE_RESPONSE: return "ResultCode::INTERMEDIATE_RESPONSE";
        case __hlt_ldap::LDAP::ResultCode::TLS_NOT_SUPPORTED: return "ResultCode::TLS_NOT_SUPPORTED";
        case __hlt_ldap::LDAP::ResultCode::AMBIGUOUS_RESPONSE: return "ResultCode::AMBIGUOUS_RESPONSE";
        case __hlt_ldap::LDAP::ResultCode::INVALID_RESPONSE: return "ResultCode::INVALID_RESPONSE";
        case __hlt_ldap::LDAP::ResultCode::REFERRAL_LIMIT_EXCEEDED: return "ResultCode::REFERRAL_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::CLIENT_LOOP: return "ResultCode::CLIENT_LOOP";
        case __hlt_ldap::LDAP::ResultCode::MORE_RESULTS_TO_RETURN: return "ResultCode::MORE_RESULTS_TO_RETURN";
        case __hlt_ldap::LDAP::ResultCode::NO_RESULTS_RETURNED: return "ResultCode::NO_RESULTS_RETURNED";
        case __hlt_ldap::LDAP::ResultCode::CONTROL_NOT_FOUND: return "ResultCode::CONTROL_NOT_FOUND";
        case __hlt_ldap::LDAP::ResultCode::NOT_SUPPORTED: return "ResultCode::NOT_SUPPORTED";
        case __hlt_ldap::LDAP::ResultCode::CONNECT_ERROR: return "ResultCode::CONNECT_ERROR";
        case __hlt_ldap::LDAP::ResultCode::NO_MEMORY: return "ResultCode::NO_MEMORY";
        case __hlt_ldap::LDAP::ResultCode::PARAM_ERROR: return "ResultCode::PARAM_ERROR";
        case __hlt_ldap::LDAP::ResultCode::USER_CANCELED: return "ResultCode::USER_CANCELED";
        case __hlt_ldap::LDAP::ResultCode::FILTER_ERROR: return "ResultCode::FILTER_ERROR";
        case __hlt_ldap::LDAP::ResultCode::AUTH_UNKNOWN: return "ResultCode::AUTH_UNKNOWN";
        case __hlt_ldap::LDAP::ResultCode::TIMEOUT: return "ResultCode::TIMEOUT";
        case __hlt_ldap::LDAP::ResultCode::DECODING_ERROR: return "ResultCode::DECODING_ERROR";
        case __hlt_ldap::LDAP::ResultCode::ENCODING_ERROR: return "ResultCode::ENCODING_ERROR";
        case __hlt_ldap::LDAP::ResultCode::LOCAL_ERROR: return "ResultCode::LOCAL_ERROR";
        case __hlt_ldap::LDAP::ResultCode::SERVER_DOWN: return "ResultCode::SERVER_DOWN";
        case __hlt_ldap::LDAP::ResultCode::OTHER: return "ResultCode::OTHER";
        case __hlt_ldap::LDAP::ResultCode::CONTROL_ERROR: return "ResultCode::CONTROL_ERROR";
        case __hlt_ldap::LDAP::ResultCode::AFFECTS_MULTIPLE_DSAS: return "ResultCode::AFFECTS_MULTIPLE_DSAS";
        case __hlt_ldap::LDAP::ResultCode::RESULTS_TOO_LARGE: return "ResultCode::RESULTS_TOO_LARGE";
        case __hlt_ldap::LDAP::ResultCode::OBJECT_CLASS_MODS_PROHIBITED: return "ResultCode::OBJECT_CLASS_MODS_PROHIBITED";
        case __hlt_ldap::LDAP::ResultCode::ENTRY_ALREADY_EXISTS: return "ResultCode::ENTRY_ALREADY_EXISTS";
        case __hlt_ldap::LDAP::ResultCode::NOT_ALLOWED_ON_RDN: return "ResultCode::NOT_ALLOWED_ON_RDN";
        case __hlt_ldap::LDAP::ResultCode::NOT_ALLOWED_ON_NON_LEAF: return "ResultCode::NOT_ALLOWED_ON_NON_LEAF";
        case __hlt_ldap::LDAP::ResultCode::OBJECT_CLASS_VIOLATION: return "ResultCode::OBJECT_CLASS_VIOLATION";
        case __hlt_ldap::LDAP::ResultCode::NAMING_VIOLATION: return "ResultCode::NAMING_VIOLATION";
        case __hlt_ldap::LDAP::ResultCode::OFFSET_RANGE_ERROR: return "ResultCode::OFFSET_RANGE_ERROR";
        case __hlt_ldap::LDAP::ResultCode::SORT_CONTROL_MISSING: return "ResultCode::SORT_CONTROL_MISSING";
        case __hlt_ldap::LDAP::ResultCode::LOOP_DETECT: return "ResultCode::LOOP_DETECT";
        case __hlt_ldap::LDAP::ResultCode::UNWILLING_TO_PERFORM: return "ResultCode::UNWILLING_TO_PERFORM";
        case __hlt_ldap::LDAP::ResultCode::UNAVAILABLE: return "ResultCode::UNAVAILABLE";
        case __hlt_ldap::LDAP::ResultCode::BUSY: return "ResultCode::BUSY";
        case __hlt_ldap::LDAP::ResultCode::INSUFFICIENT_ACCESS_RIGHTS: return "ResultCode::INSUFFICIENT_ACCESS_RIGHTS";
        case __hlt_ldap::LDAP::ResultCode::INVALID_CREDENTIALS: return "ResultCode::INVALID_CREDENTIALS";
        case __hlt_ldap::LDAP::ResultCode::INAPPROPRIATE_AUTHENTICATION: return "ResultCode::INAPPROPRIATE_AUTHENTICATION";
        case __hlt_ldap::LDAP::ResultCode::ALIAS_DEREFERENCING_PROBLEM: return "ResultCode::ALIAS_DEREFERENCING_PROBLEM";
        case __hlt_ldap::LDAP::ResultCode::INVALID_DNSYNTAX: return "ResultCode::INVALID_DNSYNTAX";
        case __hlt_ldap::LDAP::ResultCode::ALIAS_PROBLEM: return "ResultCode::ALIAS_PROBLEM";
        case __hlt_ldap::LDAP::ResultCode::NO_SUCH_OBJECT: return "ResultCode::NO_SUCH_OBJECT";
        case __hlt_ldap::LDAP::ResultCode::INVALID_ATTRIBUTE_SYNTAX: return "ResultCode::INVALID_ATTRIBUTE_SYNTAX";
        case __hlt_ldap::LDAP::ResultCode::ATTRIBUTE_OR_VALUE_EXISTS: return "ResultCode::ATTRIBUTE_OR_VALUE_EXISTS";
        case __hlt_ldap::LDAP::ResultCode::CONSTRAINT_VIOLATION: return "ResultCode::CONSTRAINT_VIOLATION";
        case __hlt_ldap::LDAP::ResultCode::INAPPROPRIATE_MATCHING: return "ResultCode::INAPPROPRIATE_MATCHING";
        case __hlt_ldap::LDAP::ResultCode::UNDEFINED_ATTRIBUTE_TYPE: return "ResultCode::UNDEFINED_ATTRIBUTE_TYPE";
        case __hlt_ldap::LDAP::ResultCode::NO_SUCH_ATTRIBUTE: return "ResultCode::NO_SUCH_ATTRIBUTE";
        case __hlt_ldap::LDAP::ResultCode::SASL_BIND_IN_PROGRESS: return "ResultCode::SASL_BIND_IN_PROGRESS";
        case __hlt_ldap::LDAP::ResultCode::CONFIDENTIALITY_REQUIRED: return "ResultCode::CONFIDENTIALITY_REQUIRED";
        case __hlt_ldap::LDAP::ResultCode::UNAVAILABLE_CRITICAL_EXTENSION: return "ResultCode::UNAVAILABLE_CRITICAL_EXTENSION";
        case __hlt_ldap::LDAP::ResultCode::ADMIN_LIMIT_EXCEEDED: return "ResultCode::ADMIN_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::REFERRAL: return "ResultCode::REFERRAL";
        case __hlt_ldap::LDAP::ResultCode::PARTIAL_RESULTS: return "ResultCode::PARTIAL_RESULTS";
        case __hlt_ldap::LDAP::ResultCode::STRONGER_AUTH_REQUIRED: return "ResultCode::STRONGER_AUTH_REQUIRED";
        case __hlt_ldap::LDAP::ResultCode::AUTH_METHOD_NOT_SUPPORTED: return "ResultCode::AUTH_METHOD_NOT_SUPPORTED";
        case __hlt_ldap::LDAP::ResultCode::COMPARE_TRUE: return "ResultCode::COMPARE_TRUE";
        case __hlt_ldap::LDAP::ResultCode::COMPARE_FALSE: return "ResultCode::COMPARE_FALSE";
        case __hlt_ldap::LDAP::ResultCode::SIZE_LIMIT_EXCEEDED: return "ResultCode::SIZE_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::TIME_LIMIT_EXCEEDED: return "ResultCode::TIME_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::PROTOCOL_ERROR: return "ResultCode::PROTOCOL_ERROR";
        case __hlt_ldap::LDAP::ResultCode::OPERATIONS_ERROR: return "ResultCode::OPERATIONS_ERROR";
        case __hlt_ldap::LDAP::ResultCode::SUCCESS: return "ResultCode::SUCCESS";
        case __hlt_ldap::LDAP::ResultCode::Undef: return "ResultCode::Undef";
        default: return ::hilti::rt::fmt("ResultCode::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::SearchDerefAlias x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_ALWAYS: return "SearchDerefAlias::DEREF_ALWAYS";
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_FINDING_BASE: return "SearchDerefAlias::DEREF_FINDING_BASE";
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_IN_SEARCHING: return "SearchDerefAlias::DEREF_IN_SEARCHING";
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_NEVER: return "SearchDerefAlias::DEREF_NEVER";
        case __hlt_ldap::LDAP::SearchDerefAlias::Undef: return "SearchDerefAlias::Undef";
        default: return ::hilti::rt::fmt("SearchDerefAlias::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::SearchScope x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::SearchScope::SEARCH_TREE: return "SearchScope::SEARCH_TREE";
        case __hlt_ldap::LDAP::SearchScope::SEARCH_SINGLE: return "SearchScope::SEARCH_SINGLE";
        case __hlt_ldap::LDAP::SearchScope::SEARCH_BASE: return "SearchScope::SEARCH_BASE";
        case __hlt_ldap::LDAP::SearchScope::Undef: return "SearchScope::Undef";
        default: return ::hilti::rt::fmt("SearchScope::<unknown-%" PRIu64 ">", x.value());
    }
}

