// Begin of spicy_hooks_QUIC (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_quic_hlto_scope;

namespace __hlt_quic::QUIC {
    struct VariableLengthInteger;
    struct ZeroRTTPacket;
    struct UnhandledVersion;
    struct RetryPacket;
    struct LongHeaderPacketV2;
    struct LongHeaderPacketV1;
    struct LongHeaderPacket;
    struct InitialPacket;
    struct HandshakePacket;
    struct ConnectionClosePayload;
    HILTI_RT_ENUM_WITH_DEFAULT(HeaderForm, Undef, SHORT = 0, LONG = 1, Undef = -1);;
    struct VariableLengthInteger : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<VariableLengthInteger> {
        auto __self() { return ::hilti::rt::ValueReference<VariableLengthInteger>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> bytes_to_parse{};
        ::hilti::rt::integer::safe<uint64_t> result_{};
        void __on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        void __on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__VariableLengthInteger_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        VariableLengthInteger();
        VariableLengthInteger(const VariableLengthInteger&) = default;
        VariableLengthInteger(VariableLengthInteger&&) = default;
        VariableLengthInteger& operator=(const VariableLengthInteger&) = default;
        VariableLengthInteger& operator=(VariableLengthInteger&&) = default;
        VariableLengthInteger(std::optional<::hilti::rt::integer::safe<uint64_t>> bytes_to_parse, std::optional<::hilti::rt::integer::safe<uint64_t>> result_);
        template<typename F> void __visit(F _) const { _("bytes_to_parse", bytes_to_parse); _("result_", result_); }
    };

    struct ZeroRTTPacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ZeroRTTPacket> {
        auto __self() { return ::hilti::rt::ValueReference<ZeroRTTPacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__ZeroRTTPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        ZeroRTTPacket();
        ZeroRTTPacket(const ZeroRTTPacket&) = default;
        ZeroRTTPacket(ZeroRTTPacket&&) = default;
        ZeroRTTPacket& operator=(const ZeroRTTPacket&) = default;
        ZeroRTTPacket& operator=(ZeroRTTPacket&&) = default;
        ZeroRTTPacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length);
        ZeroRTTPacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("length", length); }
    };

    struct UnhandledVersion : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<UnhandledVersion> {
        auto __self() { return ::hilti::rt::ValueReference<UnhandledVersion>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<UnhandledVersion>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_QUIC__UnhandledVersion_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        UnhandledVersion();
        UnhandledVersion(const UnhandledVersion&) = default;
        UnhandledVersion(UnhandledVersion&&) = default;
        UnhandledVersion& operator=(const UnhandledVersion&) = default;
        UnhandledVersion& operator=(UnhandledVersion&&) = default;
        UnhandledVersion(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header);
        UnhandledVersion(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); }
    };

    struct RetryPacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<RetryPacket> {
        auto __self() { return ::hilti::rt::ValueReference<RetryPacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        ::hilti::rt::Bytes retry_token{};
        ::hilti::rt::Bytes integrity_tag{};
        std::optional<::hilti::rt::Bytes> data{};
        void __on_data(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__RetryPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        RetryPacket();
        RetryPacket(const RetryPacket&) = default;
        RetryPacket(RetryPacket&&) = default;
        RetryPacket& operator=(const RetryPacket&) = default;
        RetryPacket& operator=(RetryPacket&&) = default;
        RetryPacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<::hilti::rt::Bytes> retry_token, std::optional<::hilti::rt::Bytes> integrity_tag, std::optional<std::optional<::hilti::rt::Bytes>> data);
        RetryPacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("retry_token", retry_token); _("integrity_tag", integrity_tag); _("data", data); }
    };

    struct LongHeaderPacketV2 : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<LongHeaderPacketV2> {
        auto __self() { return ::hilti::rt::ValueReference<LongHeaderPacketV2>::self(this); }
        std::optional<::hilti::rt::ValueReference<InitialPacket>> initial_hdr{};
        void __on_initial_hdr(const ::hilti::rt::ValueReference<InitialPacket>& __dd);
        std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>> zerortt_hdr{};
        std::optional<::hilti::rt::ValueReference<HandshakePacket>> handshake_hdr{};
        std::optional<::hilti::rt::ValueReference<RetryPacket>> retry_hdr{};
        void __on_retry_hdr(const ::hilti::rt::ValueReference<RetryPacket>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<LongHeaderPacketV2>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__LongHeaderPacketV2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_outer{};
        LongHeaderPacketV2();
        LongHeaderPacketV2(const LongHeaderPacketV2&) = default;
        LongHeaderPacketV2(LongHeaderPacketV2&&) = default;
        LongHeaderPacketV2& operator=(const LongHeaderPacketV2&) = default;
        LongHeaderPacketV2& operator=(LongHeaderPacketV2&&) = default;
        LongHeaderPacketV2(std::optional<std::optional<::hilti::rt::ValueReference<InitialPacket>>> initial_hdr, std::optional<std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>>> zerortt_hdr, std::optional<std::optional<::hilti::rt::ValueReference<HandshakePacket>>> handshake_hdr, std::optional<std::optional<::hilti::rt::ValueReference<RetryPacket>>> retry_hdr);
        LongHeaderPacketV2(::hilti::rt::ValueReference<LongHeaderPacket>& __p_outer);
        template<typename F> void __visit(F _) const { _("initial_hdr", initial_hdr); _("zerortt_hdr", zerortt_hdr); _("handshake_hdr", handshake_hdr); _("retry_hdr", retry_hdr); }
    };

    struct LongHeaderPacketV1 : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<LongHeaderPacketV1> {
        auto __self() { return ::hilti::rt::ValueReference<LongHeaderPacketV1>::self(this); }
        std::optional<::hilti::rt::ValueReference<InitialPacket>> initial_hdr{};
        void __on_initial_hdr(const ::hilti::rt::ValueReference<InitialPacket>& __dd);
        std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>> zerortt_hdr{};
        std::optional<::hilti::rt::ValueReference<HandshakePacket>> handshake_hdr{};
        std::optional<::hilti::rt::ValueReference<RetryPacket>> retry_hdr{};
        void __on_retry_hdr(const ::hilti::rt::ValueReference<RetryPacket>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<LongHeaderPacketV1>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__LongHeaderPacketV1_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_outer{};
        LongHeaderPacketV1();
        LongHeaderPacketV1(const LongHeaderPacketV1&) = default;
        LongHeaderPacketV1(LongHeaderPacketV1&&) = default;
        LongHeaderPacketV1& operator=(const LongHeaderPacketV1&) = default;
        LongHeaderPacketV1& operator=(LongHeaderPacketV1&&) = default;
        LongHeaderPacketV1(std::optional<std::optional<::hilti::rt::ValueReference<InitialPacket>>> initial_hdr, std::optional<std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>>> zerortt_hdr, std::optional<std::optional<::hilti::rt::ValueReference<HandshakePacket>>> handshake_hdr, std::optional<std::optional<::hilti::rt::ValueReference<RetryPacket>>> retry_hdr);
        LongHeaderPacketV1(::hilti::rt::ValueReference<LongHeaderPacket>& __p_outer);
        template<typename F> void __visit(F _) const { _("initial_hdr", initial_hdr); _("zerortt_hdr", zerortt_hdr); _("handshake_hdr", handshake_hdr); _("retry_hdr", retry_hdr); }
    };

    struct LongHeaderPacket : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<LongHeaderPacket> {
        auto __self() { return ::hilti::rt::ValueReference<LongHeaderPacket>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> encrypted_offset{};
        ::hilti::rt::integer::safe<uint64_t> payload_length{};
        ::hilti::rt::integer::safe<uint8_t> client_conn_id_length{};
        ::hilti::rt::integer::safe<uint8_t> server_conn_id_length{};
        ::hilti::rt::Bool is_initial{};
        ::hilti::rt::Bool is_retry{};
        std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> first_byte{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> version{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> dest_conn_id_len{};
        void __on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Bytes> dest_conn_id{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> src_conn_id_len{};
        void __on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Bytes> src_conn_id{};
        std::optional<::hilti::rt::ValueReference<LongHeaderPacketV1>> v1{};
        std::optional<::hilti::rt::ValueReference<LongHeaderPacketV2>> v2{};
        std::optional<::hilti::rt::ValueReference<UnhandledVersion>> unknown{};
        void __on_unknown(const ::hilti::rt::ValueReference<UnhandledVersion>& __dd);
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<LongHeaderPacket>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__LongHeaderPacket_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        LongHeaderPacket();
        LongHeaderPacket(const LongHeaderPacket&) = default;
        LongHeaderPacket(LongHeaderPacket&&) = default;
        LongHeaderPacket& operator=(const LongHeaderPacket&) = default;
        LongHeaderPacket& operator=(LongHeaderPacket&&) = default;
        LongHeaderPacket(std::optional<::hilti::rt::integer::safe<uint64_t>> encrypted_offset, std::optional<::hilti::rt::integer::safe<uint64_t>> payload_length, std::optional<::hilti::rt::integer::safe<uint8_t>> client_conn_id_length, std::optional<::hilti::rt::integer::safe<uint8_t>> server_conn_id_length, std::optional<::hilti::rt::Bool> is_initial, std::optional<::hilti::rt::Bool> is_retry, std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> version, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> dest_conn_id_len, std::optional<std::optional<::hilti::rt::Bytes>> dest_conn_id, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> src_conn_id_len, std::optional<std::optional<::hilti::rt::Bytes>> src_conn_id, std::optional<std::optional<::hilti::rt::ValueReference<LongHeaderPacketV1>>> v1, std::optional<std::optional<::hilti::rt::ValueReference<LongHeaderPacketV2>>> v2, std::optional<std::optional<::hilti::rt::ValueReference<UnhandledVersion>>> unknown);
        template<typename F> void __visit(F _) const { _("encrypted_offset", encrypted_offset); _("payload_length", payload_length); _("client_conn_id_length", client_conn_id_length); _("server_conn_id_length", server_conn_id_length); _("is_initial", is_initial); _("is_retry", is_retry); _("first_byte", first_byte); _("version", version); _("dest_conn_id_len", dest_conn_id_len); _("dest_conn_id", dest_conn_id); _("src_conn_id_len", src_conn_id_len); _("src_conn_id", src_conn_id); _("v1", v1); _("v2", v2); _("unknown", unknown); }
    };

    struct InitialPacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<InitialPacket> {
        auto __self() { return ::hilti::rt::ValueReference<InitialPacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> token_length{};
        std::optional<::hilti::rt::Bytes> token{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__InitialPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        InitialPacket();
        InitialPacket(const InitialPacket&) = default;
        InitialPacket(InitialPacket&&) = default;
        InitialPacket& operator=(const InitialPacket&) = default;
        InitialPacket& operator=(InitialPacket&&) = default;
        InitialPacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> token_length, std::optional<std::optional<::hilti::rt::Bytes>> token, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length);
        InitialPacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("token_length", token_length); _("token", token); _("length", length); }
    };

    struct HandshakePacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<HandshakePacket> {
        auto __self() { return ::hilti::rt::ValueReference<HandshakePacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__HandshakePacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        HandshakePacket();
        HandshakePacket(const HandshakePacket&) = default;
        HandshakePacket(HandshakePacket&&) = default;
        HandshakePacket& operator=(const HandshakePacket&) = default;
        HandshakePacket& operator=(HandshakePacket&&) = default;
        HandshakePacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length);
        HandshakePacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("length", length); }
    };

    struct ConnectionClosePayload : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ConnectionClosePayload> {
        auto __self() { return ::hilti::rt::ValueReference<ConnectionClosePayload>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> error_code{};
        std::optional<::hilti::rt::Bytes> unknown_frame_type{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> frame_type{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> reason_phrase_length{};
        std::optional<::hilti::rt::Bytes> reason_phrase{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_8_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__ConnectionClosePayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        ConnectionClosePayload();
        ConnectionClosePayload(const ConnectionClosePayload&) = default;
        ConnectionClosePayload(ConnectionClosePayload&&) = default;
        ConnectionClosePayload& operator=(const ConnectionClosePayload&) = default;
        ConnectionClosePayload& operator=(ConnectionClosePayload&&) = default;
        ConnectionClosePayload(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> error_code, std::optional<std::optional<::hilti::rt::Bytes>> unknown_frame_type, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> frame_type, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> reason_phrase_length, std::optional<std::optional<::hilti::rt::Bytes>> reason_phrase);
        ConnectionClosePayload(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("error_code", error_code); _("unknown_frame_type", unknown_frame_type); _("frame_type", frame_type); _("reason_phrase_length", reason_phrase_length); _("reason_phrase", reason_phrase); }
    };

}

namespace __hlt_quic::spicy_hooks_QUIC {
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_QUIC_initial_packet_f27eeb083e745526 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_QUIC_retry_packet_cff981a37746b782 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40 = {};
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_quic::QUIC::HeaderForm x, adl::tag) -> std::string;
}

namespace __hlt_quic::QUIC {
    inline auto operator<<(std::ostream& o, HeaderForm x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::VariableLengthInteger& x) -> std::ostream&;
    extern void __hook_VariableLengthInteger___on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ZeroRTTPacket& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacket& x) -> std::ostream&;
    extern void __hook_ZeroRTTPacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::ZeroRTTPacket>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::UnhandledVersion& x) -> std::ostream&;
    extern void __hook_UnhandledVersion___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::RetryPacket& x) -> std::ostream&;
    extern void __hook_RetryPacket___on_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __self);
    extern void __hook_RetryPacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacketV2& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::InitialPacket& x) -> std::ostream&;
    extern void __hook_LongHeaderPacketV2___on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::HandshakePacket& x) -> std::ostream&;
    extern void __hook_LongHeaderPacketV2___on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacketV1& x) -> std::ostream&;
    extern void __hook_LongHeaderPacketV1___on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacket___on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_unknown(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __self);
    extern void __hook_InitialPacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __self);
    extern void __hook_HandshakePacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::HandshakePacket>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ConnectionClosePayload& x) -> std::ostream&;
    extern void __hook_ConnectionClosePayload___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::ConnectionClosePayload>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_ConnectionClosePayload___on_0x25_done_5080(::hilti::rt::ValueReference<QUIC::ConnectionClosePayload>& __self);
}

namespace __hlt_quic::QUIC {
    extern void __hook_ConnectionClosePayload___on_0x25_done(::hilti::rt::ValueReference<QUIC::ConnectionClosePayload>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_ConnectionClosePayload___on_0x25_done_5080(::hilti::rt::ValueReference<QUIC::ConnectionClosePayload>& __self);
    extern void __hook_HandshakePacket___on_0x25_done_756(::hilti::rt::ValueReference<QUIC::HandshakePacket>& __self);
}

namespace __hlt_quic::QUIC {
    extern void __hook_HandshakePacket___on_0x25_done(::hilti::rt::ValueReference<QUIC::HandshakePacket>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_HandshakePacket___on_0x25_done_756(::hilti::rt::ValueReference<QUIC::HandshakePacket>& __self);
    extern void __hook_InitialPacket___on_0x25_done_9779(::hilti::rt::ValueReference<QUIC::InitialPacket>& __self);
}

namespace __hlt_quic::QUIC {
    extern void __hook_InitialPacket___on_0x25_done(::hilti::rt::ValueReference<QUIC::InitialPacket>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_InitialPacket___on_0x25_done_9779(::hilti::rt::ValueReference<QUIC::InitialPacket>& __self);
    extern void __hook_RetryPacket___on_0x25_done_ede8(::hilti::rt::ValueReference<QUIC::RetryPacket>& __self);
}

namespace __hlt_quic::QUIC {
    extern void __hook_RetryPacket___on_0x25_done(::hilti::rt::ValueReference<QUIC::RetryPacket>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_RetryPacket___on_0x25_done_ede8(::hilti::rt::ValueReference<QUIC::RetryPacket>& __self);
    extern void __hook_UnhandledVersion___on_0x25_done_9967(::hilti::rt::ValueReference<QUIC::UnhandledVersion>& __self);
}

namespace __hlt_quic::QUIC {
    extern void __hook_UnhandledVersion___on_0x25_done(::hilti::rt::ValueReference<QUIC::UnhandledVersion>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_UnhandledVersion___on_0x25_done_9967(::hilti::rt::ValueReference<QUIC::UnhandledVersion>& __self);
    extern void __hook_ZeroRTTPacket___on_0x25_done_d810(::hilti::rt::ValueReference<QUIC::ZeroRTTPacket>& __self);
}

namespace __hlt_quic::QUIC {
    extern void __hook_ZeroRTTPacket___on_0x25_done(::hilti::rt::ValueReference<QUIC::ZeroRTTPacket>& __self);
}

namespace __hlt_quic::spicy_hooks_QUIC {
    extern void __hook_ZeroRTTPacket___on_0x25_done_d810(::hilti::rt::ValueReference<QUIC::ZeroRTTPacket>& __self);
    extern void __init_globals(::hilti::rt::Context* ctx);
    extern void __destroy_globals(::hilti::rt::Context* ctx);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_quic::spicy_hooks_QUIC::__register_module)

inline void __hlt_quic::QUIC::ConnectionClosePayload::__on_0x25_done() {
    auto __self = QUIC::ConnectionClosePayload::__self();
    return __hlt_quic::QUIC::__hook_ConnectionClosePayload___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::HandshakePacket::__on_0x25_done() {
    auto __self = QUIC::HandshakePacket::__self();
    return __hlt_quic::QUIC::__hook_HandshakePacket___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::InitialPacket::__on_0x25_done() {
    auto __self = QUIC::InitialPacket::__self();
    return __hlt_quic::QUIC::__hook_InitialPacket___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::LongHeaderPacket::__on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = QUIC::LongHeaderPacket::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacket___on_dest_conn_id_len(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacket::__on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = QUIC::LongHeaderPacket::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacket___on_src_conn_id_len(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacket::__on_unknown(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd) {
    auto __self = QUIC::LongHeaderPacket::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacket___on_unknown(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacketV1::__on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV1::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV1___on_initial_hdr(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacketV1::__on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV1::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV1___on_retry_hdr(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacketV2::__on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV2::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV2___on_initial_hdr(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacketV2::__on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV2::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV2___on_retry_hdr(__dd, __self);
}

inline void __hlt_quic::QUIC::RetryPacket::__on_0x25_done() {
    auto __self = QUIC::RetryPacket::__self();
    return __hlt_quic::QUIC::__hook_RetryPacket___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::RetryPacket::__on_data(const ::hilti::rt::Bytes& __dd) {
    auto __self = QUIC::RetryPacket::__self();
    return __hlt_quic::QUIC::__hook_RetryPacket___on_data(__dd, __self);
}

inline void __hlt_quic::QUIC::UnhandledVersion::__on_0x25_done() {
    auto __self = QUIC::UnhandledVersion::__self();
    return __hlt_quic::QUIC::__hook_UnhandledVersion___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::VariableLengthInteger::__on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = QUIC::VariableLengthInteger::__self();
    return __hlt_quic::QUIC::__hook_VariableLengthInteger___on__anon(__dd, __self);
}

inline void __hlt_quic::QUIC::VariableLengthInteger::__on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = QUIC::VariableLengthInteger::__self();
    return __hlt_quic::QUIC::__hook_VariableLengthInteger___on__anon_3_foreach(__dd, __stop, __self);
}

inline void __hlt_quic::QUIC::ZeroRTTPacket::__on_0x25_done() {
    auto __self = QUIC::ZeroRTTPacket::__self();
    return __hlt_quic::QUIC::__hook_ZeroRTTPacket___on_0x25_done(__self);
}

inline auto __hlt_quic::QUIC::operator<<(std::ostream& o, HeaderForm x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern void __hlt_quic::spicy_hooks_QUIC::__destroy_globals(::hilti::rt::Context* ctx) {
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c.reset();;
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a.reset();;
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526.reset();;
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782.reset();;
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a.reset();;
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40.reset();;
}

extern void __hlt_quic::spicy_hooks_QUIC::__hook_ConnectionClosePayload___on_0x25_done_5080(::hilti::rt::ValueReference<QUIC::ConnectionClosePayload>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:22");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:22");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:22");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{7U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).version), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).dest_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).src_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*::hilti::rt::optional::value((*__self).error_code)).result_, ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c), ::hilti::rt::integer::safe<std::uint64_t>{5U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).reason_phrase), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c), ::hilti::rt::integer::safe<std::uint64_t>{6U})));
    ::zeek::spicy::rt::raise_event((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c), std::move(args));
}

extern void __hlt_quic::spicy_hooks_QUIC::__hook_HandshakePacket___on_0x25_done_756(::hilti::rt::ValueReference<QUIC::HandshakePacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:17");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:17");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:17");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{5U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).version), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).dest_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).src_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    ::zeek::spicy::rt::raise_event((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a), std::move(args));
}

extern void __hlt_quic::spicy_hooks_QUIC::__hook_InitialPacket___on_0x25_done_9779(::hilti::rt::ValueReference<QUIC::InitialPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:13");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:13");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:13");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{5U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).version), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).dest_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).src_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    ::zeek::spicy::rt::raise_event((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526), std::move(args));
}

extern void __hlt_quic::spicy_hooks_QUIC::__hook_RetryPacket___on_0x25_done_ede8(::hilti::rt::ValueReference<QUIC::RetryPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:15");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:15");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:15");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{7U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).version), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).dest_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).src_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).retry_token, ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782), ::hilti::rt::integer::safe<std::uint64_t>{5U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).integrity_tag, ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782), ::hilti::rt::integer::safe<std::uint64_t>{6U})));
    ::zeek::spicy::rt::raise_event((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782), std::move(args));
}

extern void __hlt_quic::spicy_hooks_QUIC::__hook_UnhandledVersion___on_0x25_done_9967(::hilti::rt::ValueReference<QUIC::UnhandledVersion>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:24");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:24");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:24");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{5U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).version), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).dest_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).src_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    ::zeek::spicy::rt::raise_event((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a), std::move(args));
}

extern void __hlt_quic::spicy_hooks_QUIC::__hook_ZeroRTTPacket___on_0x25_done_d810(::hilti::rt::ValueReference<QUIC::ZeroRTTPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:19");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:19");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.evt:19");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{5U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).version), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).dest_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*(*__self).header).src_conn_id), ::zeek::spicy::rt::event_arg_type((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    ::zeek::spicy::rt::raise_event((*__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40), std::move(args));
}

extern void __hlt_quic::spicy_hooks_QUIC::__init_globals(::hilti::rt::Context* ctx) {
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_connection_close_frame_6d3973cf62a0f11c = ::zeek::spicy::rt::internal_handler("QUIC::connection_close_frame"s);
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_handshake_packet_cc93b3fe38bb4e3a = ::zeek::spicy::rt::internal_handler("QUIC::handshake_packet"s);
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_initial_packet_f27eeb083e745526 = ::zeek::spicy::rt::internal_handler("QUIC::initial_packet"s);
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_retry_packet_cff981a37746b782 = ::zeek::spicy::rt::internal_handler("QUIC::retry_packet"s);
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_unhandled_version_bfe1743cdde7060a = ::zeek::spicy::rt::internal_handler("QUIC::unhandled_version"s);
    ::__hlt_quic::spicy_hooks_QUIC::__zeek_handler_QUIC_zero_rtt_packet_31a9a1c6190ac40 = ::zeek::spicy::rt::internal_handler("QUIC::zero_rtt_packet"s);
}

extern void __hlt_quic::spicy_hooks_QUIC::__register_module() { ::hilti::rt::detail::registerModule({ "spicy_hooks_QUIC", __hlt_quic_hlto_scope, nullptr, &__init_globals, &__destroy_globals, nullptr}); }

inline auto hilti::rt::detail::adl::to_string(__hlt_quic::QUIC::HeaderForm x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_quic::QUIC::HeaderForm::LONG: return "HeaderForm::LONG";
        case __hlt_quic::QUIC::HeaderForm::SHORT: return "HeaderForm::SHORT";
        case __hlt_quic::QUIC::HeaderForm::Undef: return "HeaderForm::Undef";
        default: return ::hilti::rt::fmt("HeaderForm::<unknown-%" PRIu64 ">", x.value());
    }
}

