// Begin of Syslog (from "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>

extern const char* __hlt_syslog_hlto_scope;

namespace __hlt_syslog::Syslog {
    struct Priority;
    struct Message;
    struct Priority : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Priority> {
        auto __self() { return ::hilti::rt::ValueReference<Priority>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint64_t>> value{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Syslog__Priority_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Priority();
        Priority(const Priority&) = default;
        Priority(Priority&&) = default;
        Priority& operator=(const Priority&) = default;
        Priority& operator=(Priority&&) = default;
        Priority(std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> value);
        template<typename F> void __visit(F _) const { _("value", value); }
    };

    struct Message : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Message> {
        auto __self() { return ::hilti::rt::ValueReference<Message>::self(this); }
        std::optional<::hilti::rt::ValueReference<Priority>> prio{};
        std::optional<::hilti::rt::Bytes> msg{};
        ::hilti::rt::integer::safe<uint64_t> severity{};
        ::hilti::rt::integer::safe<uint64_t> facility{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Syslog__Message_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Message();
        Message(const Message&) = default;
        Message(Message&&) = default;
        Message& operator=(const Message&) = default;
        Message& operator=(Message&&) = default;
        Message(std::optional<std::optional<::hilti::rt::ValueReference<Priority>>> prio, std::optional<std::optional<::hilti::rt::Bytes>> msg, std::optional<::hilti::rt::integer::safe<uint64_t>> severity, std::optional<::hilti::rt::integer::safe<uint64_t>> facility);
        template<typename F> void __visit(F _) const { _("prio", prio); _("msg", msg); _("severity", severity); _("facility", facility); }
    };

    const ::hilti::rt::Bytes __ctor__bytes = "<"_b;
    const ::hilti::rt::Bytes __ctor__bytes_2 = ">"_b;
    const ::hilti::rt::RegExp __ctor__regexp = ::hilti::rt::RegExp(std::string{"[[:digit:]]+"}, {});
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Message0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Syslog0x400x40Priority0x25uses_sync_advance = ::hilti::rt::Bool(false);
    extern auto operator<<(std::ostream& o, const __hlt_syslog::Syslog::Priority& x) -> std::ostream&;
    Priority::Priority() {
    }

    Priority::Priority(std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> value) : Priority() {
        if ( value ) this->value = std::move(*value);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_syslog::Syslog::Message& x) -> std::ostream&;
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message>& __self);
    Message::Message() {
    {
        severity = ::hilti::rt::integer::safe<std::uint64_t>{999U};
        facility = ::hilti::rt::integer::safe<std::uint64_t>{999U};
    }
    }

    Message::Message(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_syslog::Syslog::Priority>>> prio, std::optional<std::optional<::hilti::rt::Bytes>> msg, std::optional<::hilti::rt::integer::safe<uint64_t>> severity, std::optional<::hilti::rt::integer::safe<uint64_t>> facility) : Message() {
        if ( prio ) this->prio = std::move(*prio);
        if ( msg ) this->msg = std::move(*msg);
        if ( severity ) this->severity = std::move(*severity);
        if ( facility ) this->facility = std::move(*facility);
    }

    
}

namespace spicy::rt {
    extern void accept_input();
}

namespace __hlt_syslog::Syslog {
    extern void __hook_Message___on_0x25_done_b6ef(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_0x25_done_b6ef(::hilti::rt::ValueReference<Message>& __self);
}

namespace hlt_syslog::Syslog::Message {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_syslog::Syslog {
    extern void __register_Syslog_Message();
    extern void __register_Syslog_Priority();
    extern void __init_module();
    extern void __register_module();
}

namespace __hlt_syslog::type_info { namespace {
    extern const ::hilti::rt::TypeInfo __ti_Syslog__Priority_namex2aSyslog__Priorityx2b;
    extern const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b;
    const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b = { "hilti::RecoverableFailure", "hilti::RecoverableFailure", new ::hilti::rt::type_info::Exception() };
    const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b = { {}, "optional<spicy::RecoverableFailure>", new ::hilti::rt::type_info::Optional(&type_info::__ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::RecoverableFailure>()) };
    const ::hilti::rt::TypeInfo __ti_Syslog__Priority_namex2aSyslog__Priorityx2b = { "Syslog::Priority", "Syslog::Priority", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "value", &::hilti::rt::type_info::uint64, offsetof(Syslog::Priority, value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(Syslog::Priority, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_Syslog__Message_namex2aSyslog__Messagex2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_Priority__value_refx2anamex2aSyslog__Priorityx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_Priority__value_refx2anamex2aSyslog__Priorityx2bx2b = { {}, "value_ref<Priority>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_Syslog__Priority_namex2aSyslog__Priorityx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_syslog::Syslog::Priority>()) };
    const ::hilti::rt::TypeInfo __ti_Syslog__Message_namex2aSyslog__Messagex2b = { "Syslog::Message", "Syslog::Message", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "prio", &type_info::__ti_value_ref_Priority__value_refx2anamex2aSyslog__Priorityx2bx2b, offsetof(Syslog::Message, prio), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_syslog::Syslog::Priority>>() }, ::hilti::rt::type_info::struct_::Field{ "msg", &::hilti::rt::type_info::bytes, offsetof(Syslog::Message, msg), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "severity", &::hilti::rt::type_info::uint64, offsetof(Syslog::Message, severity), false, false }, ::hilti::rt::type_info::struct_::Field{ "facility", &::hilti::rt::type_info::uint64, offsetof(Syslog::Message, facility), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(Syslog::Message, __error), true, false }})) };
} }

HILTI_PRE_INIT(__hlt_syslog::Syslog::__register_module)

inline void __hlt_syslog::Syslog::Message::__on_0x25_done() {
    auto __self = Syslog::Message::__self();
    return __hlt_syslog::Syslog::__hook_Message___on_0x25_done(__self);
}

auto __hlt_syslog::Syslog::Message::__parse_Syslog__Message_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:10:9-10:18");

    // Begin parsing production: LookAhead: switch_lha_2 -> {Ctor: _anon_2 -> b"<" (const bytes) (id 1)}: switch_case_1 | {Variable: _anon -> void (not a literal)}: switch_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_lha_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: LookAhead: switch_lha_2 -> {Ctor: _anon_2 -> b"<" (const bytes) (id 1)}: switch_case_1 | {Variable: _anon -> void (not a literal)}: switch_case_2;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_1;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:13:10-13:14");

        // Begin parsing production: Variable: msg -> bytes;
        ::spicy::rt::detail::waitForEod(__data, __cur, (__lhs_1=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        ::hilti::rt::optional::valueOrInit((*__self).msg) = __cur.data();
        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: msg -> bytes;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_syslog::Syslog::Message::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_Syslog__Message_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_syslog::Syslog::Message::__parse_switch_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:10:9-10:18");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_2;
        if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_2=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
        }
        else {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_3;
            ::hilti::rt::stream::SafeConstIterator __literal = ((::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_3=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) && (__cur.startsWith(__hlt_syslog::Syslog::__ctor__bytes)) ? __cur.begin() + ::hilti::rt::integer::safe<std::uint64_t>{1U} : __cur.begin());
            if ( __literal != __cur.begin() ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{1};
                __lahe = __literal;
            }

            ::spicy::rt::detail::printParserState("Syslog::Message"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
        }
    }

    if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{1} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:9:9-9:26");

        // Begin parsing production: Block: switch_case_1 -> Resolved_2;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:28:17-32:1");

            // Begin parsing production: Unit: Syslog__Priority -> _anon_2 value _anon_3;
            ::hilti::rt::optional::valueOrInit((*__self).prio) = (__hlt_syslog::Syslog::Priority());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).prio)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: Syslog__Priority -> _anon_2 value _anon_3;
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_case_1 -> Resolved_2;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:10:9-10:18");
        throw ::spicy::rt::ParseError("expected look-ahead token, but reached end-of-data"sv, "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:10:9-10:18");
    }

    else  {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:10:9-10:18");

        // Begin parsing production: Block: switch_case_2 -> _anon;
        ::hilti::rt::debug::indent("spicy"sv);
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:10:14-10:17");

        // Begin parsing production: Variable: _anon -> void;
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon -> void;

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_case_2 -> _anon;
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_syslog::Syslog::Message::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");
    ::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message> __unit = ::hilti::rt::reference::make_value<__hlt_syslog::Syslog::Message>((__hlt_syslog::Syslog::Message()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");

    // Begin parsing production: Unit: Syslog__Message -> switch_lha_2 msg;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Syslog__Message -> switch_lha_2 msg;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_syslog::Syslog::Message::parse2(::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");

    // Begin parsing production: Unit: Syslog__Message -> switch_lha_2 msg;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Syslog__Message -> switch_lha_2 msg;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_syslog::Syslog::Message::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");
    ::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message> __unit = ::hilti::rt::reference::make_value<__hlt_syslog::Syslog::Message>((__hlt_syslog::Syslog::Message()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_Syslog__Message_namex2aSyslog__Messagex2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:7:23-26:1");

    // Begin parsing production: Unit: Syslog__Message -> switch_lha_2 msg;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Syslog__Message -> switch_lha_2 msg;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_syslog::Syslog::Priority::__parse_Syslog__Priority_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_6;
    auto __self = Priority::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:28:17-32:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient__anon_2;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:29:7-29:10");

    // Begin parsing production: Ctor: _anon_2_2 -> b"<" (const bytes);
    if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
        if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{1} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:29:7-29:10");
            throw ::spicy::rt::ParseError("unexpected token to consume"sv, "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:29:7-29:10");
        }

        if ( __cur.sub(__cur.begin(), __lahe) != __hlt_syslog::Syslog::__ctor__bytes ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:29:7-29:10");
            throw ::spicy::rt::ParseError("unexpected data when consuming token"sv, "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:29:7-29:10");
        }

        __transient__anon_2 = __hlt_syslog::Syslog::__ctor__bytes;
        __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
        __cur = __cur.advance(__lahe);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }
    }
    else {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_4;
        ::spicy::rt::detail::expectBytesLiteral(__data, __cur, __hlt_syslog::Syslog::__ctor__bytes, "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:29:7-29:10"sv, (__lhs_4=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __transient__anon_2 = __hlt_syslog::Syslog::__ctor__bytes;
        __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{1U});
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }
    }

    // End parsing production: Ctor: _anon_2_2 -> b"<" (const bytes);

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:30:12-30:25");
        ::hilti::rt::Bytes __parsed_value;
        ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

        // Begin parsing production: Ctor: value_2 -> /[[:digit:]]+/ (regexp);
        ::hilti::rt::stream::View __ncur = __cur;
        for ( ::hilti::rt::regexp::MatchState ms = __hlt_syslog::Syslog::__ctor__regexp.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
            ::hilti::rt::integer::safe<int32_t> __rc;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:30:12-30:25");
            std::tie(__rc, __ncur) = ms.advance(__ncur);
            if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_5;
                // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
                ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_5=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                continue;
            }

            else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:30:12-30:25");
                throw ::spicy::rt::ParseError("failed to match regular expression"sv, "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:30:12-30:25");
            }

            else  {
                __captures = ms.captures(__cur);
                __parsed_value = __cur.sub(__ncur.begin()).data();
                __cur = __ncur;
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }

                break;
            }
        }

        // End parsing production: Ctor: value_2 -> /[[:digit:]]+/ (regexp);

        {
            ::hilti::rt::Bytes __dd = __parsed_value;
            ::hilti::rt::optional::valueOrInit((*__self).value) = __dd.toUInt();
        }

    }

    ::hilti::rt::Bytes __transient__anon_3;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:31:7-31:10");

    // Begin parsing production: Ctor: _anon_3_2 -> b">" (const bytes);
    ::spicy::rt::detail::expectBytesLiteral(__data, __cur, __hlt_syslog::Syslog::__ctor__bytes_2, "/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:31:7-31:10"sv, (__lhs_6=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
    __transient__anon_3 = __hlt_syslog::Syslog::__ctor__bytes_2;
    __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{1U});
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Ctor: _anon_3_2 -> b">" (const bytes);

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_syslog::Syslog::Priority::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Priority::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:28:17-32:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_Syslog__Priority_2_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern void __hlt_syslog::Syslog::__hook_Message___on_0x25_done_b6ef(::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:16:9-16:29");
    ::spicy::rt::accept_input();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:18:9-21:9");
    if ( (*__self).prio.has_value() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:19:13-19:52");
        (*__self).severity = ((::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).prio)).value) & ::hilti::rt::integer::safe<std::uint64_t>{7U}));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/syslog/syslog.spicy:20:13-20:59");
        (*__self).facility = (((::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).prio)).value) & ::hilti::rt::integer::safe<std::uint64_t>{1016U})) >> ::hilti::rt::integer::safe<std::uint64_t>{3U});
    }
}

extern void __hlt_syslog::Syslog::__init_module() {
    __hlt_syslog::Syslog::__register_Syslog_Message();
    __hlt_syslog::Syslog::__register_Syslog_Priority();
}

extern void __hlt_syslog::Syslog::__register_Syslog_Message() {
    ::hilti::rt::detail::checkStack();
    Syslog::Message::__parser = ::spicy::rt::Parser("Syslog::Message"sv, ::hilti::rt::Bool(true), hlt_syslog::Syslog::Message::parse1, hlt_syslog::Syslog::Message::parse2, hlt_syslog::Syslog::Message::parse3, ::hilti::rt::Null(), &type_info::__ti_Syslog__Message_namex2aSyslog__Messagex2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(Syslog::Message::__parser, std::string(__hlt_syslog_hlto_scope), ::hilti::rt::StrongReference<__hlt_syslog::Syslog::Message>());
}

extern void __hlt_syslog::Syslog::__register_Syslog_Priority() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_syslog::Syslog::__register_module() { ::hilti::rt::detail::registerModule({ "Syslog", __hlt_syslog_hlto_scope, &__init_module, nullptr, nullptr, nullptr}); }

extern auto __hlt_syslog::Syslog::operator<<(std::ostream& o, const __hlt_syslog::Syslog::Priority& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_syslog::Syslog::operator<<(std::ostream& o, const __hlt_syslog::Syslog::Message& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto hlt_syslog::Syslog::Message::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_syslog::Syslog::Message::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_syslog::Syslog::Message::parse2(::hilti::rt::ValueReference<__hlt_syslog::Syslog::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_syslog::Syslog::Message::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_syslog::Syslog::Message::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_syslog::Syslog::Message::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

